{****************************************************************************}
{                                                                            }
{                     Turbo Pascal Version 7.0                               }
{                     Turbo GIOBE  Unit                                      }
{                                                                            }
{                     Copyright (c) 2000 by ing. Giorgio OBER                }
{                                                                            }
{****************************************************************************}

{Ŀ}
{ NOME           : GIOBE.PAS                                               }
{ AUTORE         : Giorgio OBER                                            }
{ PRIMA VERSIONE : ottobre 1994                                            }
{ AGGIORNAMENTO  : giugno 2001                                             }
{ DESCRIZIONE:     Raccolta di PROCEDURE  e  FUNZIONI  originali  adatte a }
{                  facilitare lo sviluppo di PROGRAMMI  in  ambiente TURBO }
{                  PASCAL. Attualmente sono disponibili:                   }
{                                                                          }
{*[ PROCEDURE ]************************************************************}
{ VIAcur                                                     PROCEDURA n01}
{ RIPcur                                                     PROCEDURA n02}
{ STAchr    (rig,col,txt,sfo,carat);                         PROCEDURA n03}
{ ONLYchr   (rig,col,carat);                                 PROCEDURA n04}
{ ATTRchr   (rig,col,colore);                                PROCEDURA n05}
{ SALVAchr  (rig,col,numPAG);                                PROCEDURA n06}
{ RECUPchr  (rig,col,numPAG);                                PROCEDURA n07}
{ Salva     (numPAG);                                        PROCEDURA n08}
{ Recup     (numPAG);                                        PROCEDURA n09}
{ SALVAbox  (ri,co,ri1,co1,numPAG);                          PROCEDURA n10}
{ RECUPbox  (ri,co,ri1,co1,numPAG);                          PROCEDURA n11}
{ Box1      (ri,co,ri1,co1,txt,sfo,carat)                    PROCEDURA n12}
{ Box2      (ri,co,ri1,co1,txt,sfo,numPAG,carat)             PROCEDURA n13}
{ Cornice1  (rig,col,lar,alt,txt,sfo,tipo,modo)              PROCEDURA n14}
{ Cornice2  (rig,col,lar,alt,txt,sfo,ombP,ombS,tipo)         PROCEDURA n15}
{ Cornice3  (rig,col,lar,alt,txt,sfo,ombP,ombS,tipo,numPAG)  PROCEDURA n16}
{ RECUPcorn (rig,col,lar,alt:integer;numPAG);                PROCEDURA n17}
{ Cornice4  (rig,col,lar,alt,txt,sfo,ombP,ombS,tipo,ombC)    PROCEDURA n18}
{ Cornice5  (rig,lar,alt,txt,sfo,tipo,modo)                  PROCEDURA n19}
{ Riempi1   (sfo,txt:integer;carat);                         PROCEDURA n20}
{ Riempi2   (sfo,txt,tipo);                                  PROCEDURA n21}
{ Riempi3   (rigI,rigF,txt,sfo,carat);                       PROCEDURA n22}
{ Esplosione(ritardo,lar,alt,txt,sfo,tipo,nunPAG);           PROCEDURA n23}
{ PreImplos (rig,col,lar,alt,txt,sfo,numPAG);                PROCEDURA n41}
{ Implosione(ritardo,rig,col,lar,alt,sfo,numPAG);            PROCEDURA n24}
{ Anykey                                                     PROCEDURA n25}
{ CORN_DOS  (colore);                                        PROCEDURA n26}
{ Data      (riga,colonna,testo,sfondo,come);                PROCEDURA n27}
{ Ora       (riga,colonna,testo,sfondo,come);                PROCEDURA n28}
{ SETdata   (Anno,Mese,Giorno);                              PROCEDURA n29}
{ SETora    (Ora,Minuti,Secondi,Centesimi);                  PROCEDURA n30}
{ VediMouse                                                  PROCEDURA n31}
{ ViaMouse                                                   PROCEDURA n32}
{ SetMouse  (pixel,colonna,riga);                            PROCEDURA n33}
{ BoxMouse  (rig1,col1,rig2,col2,pixel);                     PROCEDURA n34}
{ CambiaCur1(inizio,fine);                                   PROCEDURA n36}
{ CambiaCur2(sfondo,colore);                                 PROCEDURA n37}
{ Delay0    (ritardo);                                       PROCEDURA n38}
{ Delay1    (ritardo);                                       PROCEDURA n39}
{ Delay2    (ritardo);                                       PROCEDURA n40}
{ INstring (    lung,stringa,max,rig,col,txt,sfo,tipo,giust);PROCEDURA n41}
{ INnumer  (num,lung,stringa,max,rig,col,txt,sfo,tipo,giust);PROCEDURA n42}
{ INexad   (num,lung,stringa,max,rig,col,txt,sfo,tipo,giust);PROCEDURA n43}
{                                                                          }
{--[ Novit febbraio 2001 ]------------------------------------------------}
{ AspettaKeyClick (VAR tasto,pulsante);                      PROCEDURA n44}
{ KeyClickMessage1 (VAR tasto:char; VAR pulsante:word;                     }
{                   txt,sfo:integer;testo1:string);          PROCEDURA n45}
{ KeyClickMessage2 (VAR tasto:char; VAR pulsante:word;                     }
{                   txt,sfo:integer;testo1:string);          PROCEDURA n46}
{                                                                          }
{--[ Novit giugno 2001 ]--------------------------------------------------}
{ NewCorn (rig,col,lar,alt,txt,sfo,ombP,ombS,tipo,numPAG);   PROCEDURE n47}
{ NewRecup (rig,col,lar,alt,numPAG);                         PROCEDURE n48}
{
{*[ FUNZIONI ]*************************************************************}
{ pulMou                   : word                            FUNZIONE  n01}
{ rigMou    (pixel:boolean): word                            FUNZIONE  n02}
{ colMou    (pixel:boolean): word                            FUNZIONE  n03}
{ DestroMou                : boolean                         FUNZIONE  n04}
{ SinistMou                : boolean                         FUNZIONE  n05}
{ CentroMou                : boolean                         FUNZIONE  n06}
{ StillKey                 : boolean                         FUNZIONE  n07}
{ Mouse                    : boolean                         FUNZIONE  n08}
{ quantiMou                : word                            FUNZIONE  n09}
{ DataIN    (VAR Anno,Mese,Giorno,NomeGiorn)  :word          FUNZIONE  n10}
{ OraIN     (VAR Ora,Minuti,Secondi,Centesimi):word          FUNZIONE  n11}
{                                                                          }
{--[ Novit febbraio 2001 ]------------------------------------------------}
{ ChkKey    (VAR ascii,scans:word):boolean                   FUNCTION  n12}
{ ChkClick  (rig,col1,col2:word):boolean                     FUNZIONE  n13}
{ ChrFind   (col,rig:integer):char;                          FUNZIONE  n14}
{}
UNIT       GIOBE;
INTERFACE
 PROCEDURE VIAcur                                                            ;
 PROCEDURE RIPcur                                                            ;
 PROCEDURE STAchr (rig,col,txt,sfo:byte;carat:char)                          ;
 PROCEDURE ONLYchr (rig,col:byte;carat:char)                                 ;
 PROCEDURE ATTRchr (rig,col,txt,sfo:byte)                                    ;
 PROCEDURE SALVAchr (rig,col,numPAG:byte)                                    ;
 PROCEDURE RECUPchr (rig,col,numPAG:byte)                                    ;
 PROCEDURE Salva (numPAG:byte)                                               ;
 PROCEDURE Recup (numPAG:byte)                                               ;
 PROCEDURE SALVAbox (ri,co,ri1,co1,numPAG:byte)                              ;
 PROCEDURE RECUPbox (ri,co,ri1,co1,numPAG:byte)                              ;
 PROCEDURE Box1 (ri,co,ri1,co1,txt,sfo:byte;carat:char)                      ;
 PROCEDURE Box2 (ri,co,ri1,co1,txt,sfo,numPAG:byte;carat:char)               ;
 PROCEDURE Cornice1 (rig,col,lar,alt,txt,sfo,tipo,modo:integer)              ;
 PROCEDURE Cornice2 (rig,col,lar,alt,txt,sfo,ombP,ombS,tipo:integer)         ;
 PROCEDURE Cornice3 (rig,col,lar,alt,txt,sfo,ombP,ombS,tipo:integer;numPAG:byte);
 PROCEDURE RECUPcorn (rig,col,lar,alt:integer;numPAG:byte)                   ;
 PROCEDURE Cornice4 (rig,col,lar,alt,txt,sfo,ombP,ombS,tipo:integer;ombC:char);
 PROCEDURE Cornice5 (rig,lar,alt,txt,sfo,tipo,modo:integer)                  ;
 PROCEDURE Riempi1 (sfo,txt:integer;carat:char)                              ;
 PROCEDURE Riempi2 (sfo,txt,tipo:integer)                                    ;
 PROCEDURE Riempi3 (rigI,rigF,txt,sfo:byte;carat:char)                       ;
 PROCEDURE Esplosione (ritardo,lar,alt,txt,sfo,tipo:integer;numPAG:byte)     ;
 PROCEDURE PreImplos  (rig,col,lar,alt,txt,sfo:integer;numPAG:byte)          ;
 PROCEDURE Implosione (ritardo,rig,col,lar,alt,sfo:integer;numPAG:byte)      ;
 PROCEDURE Anykey                                                            ;
 PROCEDURE INstring (VAR lunghezza:integer; VAR stringa: Array of char;
                                 max,rig,col,testo,sfondo,tipo,giust:integer);
 PROCEDURE INnumer  (VAR numero:longint; VAR lunghezza:integer;
                                            VAR stringa: Array of char;
                                 max,rig,col,testo,sfondo,tipo,giust:integer);
 PROCEDURE INexad   (VAR numero:longint;  VAR lunghezza:integer;
                                            VAR stringa: Array of char;
                                 max,rig,col,testo,sfondo,tipo,giust:integer);
 PROCEDURE CORN_DOS (colore:byte)                                            ;
 PROCEDURE Data(riga,colonna,testo,sfondo,come:integer)                      ;
 PROCEDURE Ora(riga,colonna,testo,sfondo,come:integer)                       ;
 PROCEDURE SETdata (Anno,Mese,Giorno:Word)                                   ;
 PROCEDURE SETora(Ora,Minuti,Secondi,Centesimi:Word)                         ;
 PROCEDURE VediMouse                                                         ;
 PROCEDURE ViaMouse                                                          ;
 PROCEDURE SetMouse (pixel:boolean; colonna,riga:word)                       ;
 PROCEDURE BoxMouse (rig1,col1,rig2,col2:word;pixel:boolean)                 ;
 PROCEDURE CambiaCur1 (inizio,fine:word)                                     ;
 PROCEDURE CambiaCur2 (sfondo,colore:word)                                   ;
 PROCEDURE Delay0 (ritardo:word)                                             ;
 PROCEDURE Delay1 (ritardo:longint)                                          ;
 PROCEDURE Delay2 (ritardo:longint)                                          ;
 PROCEDURE AspettaKeyClick (VAR tasto:char;VAR pulsante:word)                ;
 PROCEDURE KeyClickMessage1 (VAR tasto:char; VAR pulsante:word               ;
                             txt,sfo:integer;testo1:string)                  ;
 PROCEDURE KeyClickMessage2 (VAR tasto:char; VAR pulsante:word               ;
                             txt,sfo:integer;testo1:string)                  ;
 PROCEDURE NewCorn (rig,col,lar,alt,txt,sfo,ombP,ombS,tipo:byte;numPAG:byte) ;
 PROCEDURE NewRecup (rig,col,lar,alt,numPAG:byte)                            ;

 FUNCTION  pulMou: word                                                      ;
 FUNCTION  rigMou (pixel:boolean): word                                      ;
 FUNCTION  colMou (pixel:boolean): word                                      ;
 FUNCTION  DestroMou : boolean                                               ;
 FUNCTION  SinistMou : boolean                                               ;
 FUNCTION  CentroMou : boolean                                               ;
 FUNCTION  StillKey  : boolean                                               ;
 FUNCTION  Mouse     : boolean                                               ;
 FUNCTION  quantiMou : word                                                  ;
 FUNCTION  DataIN (VAR Anno,Mese,Giorno,NomeGiorn):Word                      ;
 FUNCTION  OraIN  (VAR Ora,Minuti,Secondi,Centesimi):Word                    ;
 FUNCTION  ChkKey (VAR ascii,scans:word):boolean                             ;
 FUNCTION  ChkClick (rig,col1,col2:word):boolean                             ;
 FUNCTION  ChrFind  (col,rig:integer):char                                   ;

IMPLEMENTATION
 USES CRT;

{Ŀ}
  PROCEDURE   VIAcur                                                      ;{}
{DESCRIZIONE:La procedura scritta in linguaggio macchina per  8086 consente}
{            di eliminare la visualizzazione  del   cursore, utilizzando la}
{            funzione di definizione  della dimensione e passando parametri}
{            fuori range.                                                  }
{}
 BEGIN
   asm
       PUSH    AX
       PUSH    CX
       MOV     CH,20
       MOV     CL,00H
       MOV     AH,01H
       INT     10H
       POP     CX
       POP     AX
   end;
 END; { FINE PROCEDURE VIAcur ***********************************************}

{Ŀ}
  PROCEDURE   RIPcur                                                      ;{}
{DESCRIZIONE:La procedura scritta in linguaggio macchina per  8086 consente}
{            di  ripristinare la  visualizzazione  del cursore, utilizzando}
{            la  funzione di definizione della sua dimensione con parametri}
{            corrispondenti ad un corretto range.                          }
{}
 BEGIN
   asm
       PUSH    AX
       PUSH    CX
       MOV     CH,06H
       MOV     CL,07H
       MOV     AH,01H
       INT     10H
       POP     CX
       POP     AX
   end;
 END; { FINE PROCEDURE RIPcur ***********************************************}

{Ŀ}
  PROCEDURE    STAchr (rig,col,txt,sfo:byte;carat:char)                   ;{}
{DESCRIZIONE: La procedura scritta in linguaggio macchina per 8086 consente}
{             di stampare il carattere "carat"  nella pagina video corrente}
{             alle coordinate "rig","col" con colore di primo piano "txt" e}
{             lo sfondo "sfo"; da notare che l'angolo in alto a sinistra ha}
{             coordinate [1,1] e quello in basso a destra [25,80] (MODOn3)}
{}
  VAR
    indirizzo:word;
  BEGIN
    indirizzo:=(col-1)*2+(rig-1)*160;
    asm
       PUSH    ES
       PUSH    DI
       PUSH    BX
       MOV     AX,0B800H
       MOV     ES,AX
       MOV     DI,indirizzo
       MOV     AL,carat
       MOV     BH,sfo
       SHL     BH,1
       SHL     BH,1
       SHL     BH,1
       SHL     BH,1
       MOV     BL,txt
       OR      BH,BL
       MOV     AH,BH
       MOV     ES:[DI],AX
       POP     BX
       POP     DI
       POP     ES
    end;
  END; { FINE PROCEDURA STAchr **********************************************}

{Ŀ}
  PROCEDURE    ONLYchr (rig,col:byte;carat:char)                          ;{}
{DESCRIZIONE: La procedura scritta in linguaggio macchina per 8086 consente}
{             di cambiare con "carat" il carattere posto nella pagina video}
{             corrente alle coordinate "rig","col", lasciando inalterato il}
{             suo colore di primo piano e quello del suo sfondo; da  notare}
{             che l'angolo in alto a sinistra ha  coordinate [1,1] e quello}
{             in basso a destra [25,80] (MODO TESTO standard, n3).        }
{}
  VAR
    indirizzo:word;
  BEGIN
    indirizzo:=(col-1)*2+(rig-1)*160;
    asm
       PUSH    ES
       PUSH    DI
       MOV     AX,0B800H
       MOV     ES,AX
       MOV     DI,indirizzo
       MOV     AL,carat
       MOV     ES:[DI],AL
       POP     DI
       POP     ES
    end;
  END; { FINE PROCEDURA ONLYchr *********************************************}

{Ŀ}
  PROCEDURE    ATTRchr (rig,col,txt,sfo:byte)                             ;{}
{DESCRIZIONE: La procedura scritta in linguaggio macchina per 8086 consente}
{             di cambiare il colore di primo piano e lo sfondo di un carat-}
{             tere posto nella pagina video corrente alle coordinate "rig",}
{             "col"; da notare che l'angolo in alto a sinistra ha coordina-}
{             te [1,1] e quello in basso a destra [25,80](MODO standard n3}
{}
  VAR
    indirizzo:word;
    colore:byte;
  BEGIN
    indirizzo:=(col-1)*2+(rig-1)*160;
    colore:=sfo*16+txt;
    asm
      PUSH    ES
      PUSH    DI
      MOV     AX,0B800H
      MOV     ES,AX
      MOV     DI,indirizzo
      INC     DI
      MOV     AL,colore
      MOV     ES:[DI],AL
      POP     DI
      POP     ES
    end;
  END; {FINE PROCEDURA ATTRchr **********************************************}

{Ŀ}
  PROCEDURE    SALVAchr (rig,col,numPAG:byte)                             ;{}
{DESCRIZIONE: La procedura scritta in linguaggio macchina per 8086 consente}
{             di salvare il carattere attualmente posto nella  pagina video}
{             corrente alle coordinate "rig","col" insieme ai suoi attribu-}
{             ti di colore (primo piano e sfondo);la coppia di bytes corri-}
{             spondenti viene posta nella pagina video identificata dal pa-}
{             rametro "numPAG" (0=pagina corrente, 17=pagine alternative);}
{             da notare che l'angolo in alto a sinistra ha coordinate [1,1]}
{             e quello in basso a destra [25,80] (MODO TESTO standard n3) }
{}
  VAR
     indirizzo:word;
  BEGIN
    indirizzo:=(col-1)*2+(rig-1)*160;
    asm
       PUSH    ES
       PUSH    DI
       PUSH    SI
       PUSH    CX
       MOV     AX,0B800H
       MOV     ES,AX
       MOV     DI,indirizzo
       MOV     AX,ES:[DI]
       PUSH    AX
       MOV     CL,numPAG
       MOV     CH,00H
       MOV     AX,1000H
       MUL     CX
       MOV     SI,AX
       ADD     SI,indirizzo
       POP     AX
       MOV     ES:[SI],AX
       POP     CX
       POP     SI
       POP     DI
       POP     ES
    end;
  END; { FINE PROCEDURA SALVAchr ********************************************}

{Ŀ}
  PROCEDURE    RECUPchr (rig,col,numPAG:byte)                             ;{}
{DESCRIZIONE: La procedura scritta in linguaggio macchina per 8086 consente}
{             di recuperare il carattere attualmente posto nella pagina vi-}
{             deo identificata dal  parametro "numPAG" (0= pagina corrente,}
{             17=pagine alternative)alle coordinate "rig","col" insieme ai}
{             suoi attributi di colore (primo piano e sfondo); la coppia di}
{             bytes corrispondenti viene posta nella pagina video corrente;}
{             da notare che l'angolo in alto a sinistra ha coordinate [1,1]}
{             e quello in basso a destra [25,80] (MODO TESTO standard n3) }
{}
  VAR
     indirizzo:word;
  BEGIN
    indirizzo:=(col-1)*2+(rig-1)*160;
    ASM
       PUSH    ES
       PUSH    DI
       PUSH    SI
       PUSH    CX
       PUSH    AX
       MOV     AX,0B800H
       MOV     ES,AX
       MOV     CL,numPAG
       MOV     CH,00H
       MOV     AX,1000H
       MUL     CX
       MOV     SI,AX
       ADD     SI,indirizzo
       MOV     AX,ES:[SI]
       MOV     DI,indirizzo
       MOV     ES:[DI],AX
       POP     AX
       POP     CX
       POP     SI
       POP     DI
       POP     ES
    end;
  END; { FINE PROCEDURA RECUPchr ********************************************}

{Ŀ}
  PROCEDURE    Salva (numPAG:byte)                                        ;{}
{DESCRIZIONE: La procedura scritta in linguaggio macchina per 8086 consente}
{             di trasferire tutti i caratteri (e i codici di colore ad essi}
{             associati) presenti nella pagina video corrente dentro la pa-}
{             gina video identificata dal parametro "numPAG" (0=pagina cor-}
{             rente, 17=pagine alternative).                              }
{}
 BEGIN
    asm
       PUSH    DS
       PUSH    ES
       PUSH    DI
       PUSH    SI
       PUSH    CX
       CLD
       MOV     AX,0B800H
       MOV     ES,AX
       MOV     DS,AX
       MOV     CL,numPAG
       MOV     CH,00H
       MOV     AX,1000H
       MUL     CX
       MOV     DI,AX
       MOV     SI,0000H
       MOV     CX,2000
       REP     MOVSW
       POP     CX
       POP     SI
       POP     DI
       POP     ES
       POP     DS
    end;
 END; { FINE PROCEDURA Salva ************************************************}

{Ŀ}
  PROCEDURE    Recup (numPAG:byte)                                        ;{}
{DESCRIZIONE: La procedura scritta in linguaggio macchina per 8086 consente}
{             di trasferire tutti i caratteri (e i codici di colore ad essi}
{             associati) presenti nella pagina video identificata dal para-}
{             metro "numPAG" (0= pagina corrente, 17 = pagine alternative)}
{             dentro la pagina video corrente                              }
{}
 BEGIN
    asm
       PUSH    DS
       PUSH    ES
       PUSH    DI
       PUSH    SI
       PUSH    CX
       CLD
       MOV     AX,0B800H
       MOV     ES,AX
       MOV     DS,AX
       MOV     CL,numPAG
       MOV     CH,00H
       MOV     AX,1000H
       MUL     CX
       MOV     SI,AX
       MOV     DI,0000H
       MOV     CX,2000
       REP     MOVSW
       POP     CX
       POP     SI
       POP     DI
       POP     ES
       POP     DS
    end;
 END; { FINE PROCEDURA Recup ************************************************}

{Ŀ}
  PROCEDURE    SALVAbox (ri,co,ri1,co1,numPAG:byte)                       ;{}
{DESCRIZIONE: La procedura scritta in linguaggio macchina per 8086 consente}
{             di salvare il contenuto di una finestra(caratteri e attributi}
{             di colore) attualmente posta nella pagina video corrente,rac-}
{             chiusa dall'angolo "ri,co" all'angolo"ri1,co1"(riga,colonna);}
{             tutte le coppie di bytes corrispondenti  vengono  poste nella}
{             pagina video  identificata  dal parametro "numPAG" (0= pagina}
{             corrente, 17=pagine alternative); da notare che  l'angolo in}
{            alto a sinistra ha coordinate [1,1] e quello in basso a destra}
{             [25,80] (MODO TESTO standard n3).                           }
{}
  VAR
     indirizzo,n,alto,largo:word;
  BEGIN
    n:=0;
    alto:=ri1-ri+1;
    largo:=co1-co+1;
    REPEAT
      indirizzo:=(co-1)*2+(ri-1+n)*160;
      n:=n+1;
      asm
         PUSH    ES
         PUSH    DI
         PUSH    SI
         PUSH    CX
         MOV     CL,numPAG
         MOV     CH,00H
         MOV     AX,1000H
         MUL     CX
         MOV     SI,AX
         ADD     SI,indirizzo
         MOV     AX,0B800H
         MOV     ES,AX
         MOV     DI,indirizzo
         MOV     CX,largo
   @@1:  MOV     AX,ES:[DI]
         MOV     ES:[SI],AX
         INC     DI
         INC     DI
         INC     SI
         INC     SI
         LOOP    @@1
         POP     CX
         POP     SI
         POP     DI
         POP     ES
      end;
    UNTIL n=alto;
  END; { FINE PROCEDURA SALVAbox ********************************************}

{Ŀ}
  PROCEDURE    RECUPbox (ri,co,ri1,co1,numPAG:byte)                       ;{}
{DESCRIZIONE: La procedura scritta in linguaggio macchina per 8086 consente}
{             di recuperare il contenuto di una finestra(caratteri e attri-}
{             buti di colore)  attualmente posta nella pagina video identi-}
{             ficata dal parametro "numPAG" (0= pagina corrente,17= pagine}
{             alternative), contenuta tra l'angolo "ri,co" e l'angolo "ri1,}
{             ,co1" (riga,colonna); tutte le coppie di bytes corrispondenti}
{             vengono copiate nella pagina  video  corrente; da  notare che}
{             l'angolo in alto a sinistra ha  coordinate [1,1] e  quello in}
{             basso a destra [25,80] (MODO TESTO standard n3).            }
{}
  VAR
    indirizzo,n,alto,largo:word;
  BEGIN
    n:=0;
    alto:=ri1-ri+1;
    largo:=co1-co+1;
    REPEAT
      indirizzo:=(co-1)*2+(ri-1+n)*160;
      n:=n+1;
      asm
         PUSH    ES
         PUSH    DI
         PUSH    SI
         PUSH    CX
         MOV     CL,numPAG
         MOV     CH,00H
         MOV     AX,1000H
         MUL     CX
         MOV     SI,AX
         ADD     SI,indirizzo
         MOV     AX,0B800H
         MOV     ES,AX
         MOV     DI,indirizzo
         MOV     CX,largo
  @@1:   MOV     AX,ES:[SI]
         MOV     ES:[DI],AX
         INC     DI
         INC     DI
         INC     SI
         INC     SI
         LOOP    @@1
         POP     CX
         POP     SI
         POP     DI
         POP     ES
      end;
    UNTIL n=alto;
  END; { FINE PROCEDURA RECUPbox ********************************************}

{Ŀ}
  PROCEDURE    Box1 (ri,co,ri1,co1,txt,sfo:byte;carat:char)               ;{}
{DESCRIZIONE: La procedura scritta in linguaggio macchina per 8086 consente}
{            di stampare una finestra caratteri "carat" nel colore di primo}
{             piano "txt" e di sfondo "sfo";la stampa a partire dall'angolo}
{             "ri,co" (riga,colonna) e termina con il carattere  posto nel-}
{             l'angolo "ri1,co1"  (riga,colonna);   se le  coordinate  sono}
{             "ri,co"=1,1 e "ri1,co1"=25,80 si realizza un "ClrScr"persona-}
{             lizzato analogo a quello ottenuto con "Riempi1(sfo,txt,carat)}
{             e se "ri" e "ri1" sono uguali,  con "co"=1  e "co1"=80, viene}
{             viene stampata una riga completa di 80 caratteri "carat".    }
{             Ŀ}
{             *** NB.: NON SALVA I CARATTERI SOTTOSTANTI (vedi "Box2")***}
{             ٳ}
{}
  VAR
     indirizzo,alto,largo,n:word;
  BEGIN
    n:=0;
    alto:=ri1-ri+1;
    largo:=co1-co+1;
    REPEAT
      indirizzo:=(co-1)*2+(ri-1+n)*160;
      n:=n+1;
      asm
         PUSH    ES
         PUSH    DI
         PUSH    CX
         PUSH    BX
         MOV     AX,0B800H
         MOV     ES,AX
         MOV     DI,indirizzo
         MOV     AL,carat
         MOV     BH,sfo
         SHL     BH,1
         SHL     BH,1
         SHL     BH,1
         SHL     BH,1
         MOV     BL,txt
         OR      BH,BL
         MOV     AH,BH
         MOV     CX,largo
  @@1:   MOV     ES:[DI],AX
         INC     DI
         INC     DI
         LOOP    @@1
         POP     BX
         POP     CX
         POP     DI
         POP     ES
      end;
    UNTIL n=alto;
  END; { FINE PROCEDURA Box1 ************************************************}

{Ŀ}
  PROCEDURE    Box2 (ri,co,ri1,co1,txt,sfo,numPAG:byte;carat:char)        ;{}
{DESCRIZIONE: La procedura scritta in linguaggio macchina per  8086 consente}
{             di stampare una finestra caratteri "carat" nel colore di primo}
{             piano "txt" e di sfondo "sfo"; la stampa a partire dall'angolo}
{             "ri,co" (riga,colonna) e termina con il  carattere  posto nel-}
{             l'angolo "ri1,co1"  (riga,colonna);   se  le  coordinate  sono}
{             "ri,co"=1,1 e "ri1,co1"=25,80 si realizza un "ClrScr" persona-}
{             lizzato analogo a quello ottenuto con "Riempi1(sfo,txt,carat)"}
{             e se "ri" e "ri1" sono uguali,  con "co"=1  e  "co1"=80, viene}
{             viene stampata una riga completa di 80 caratteri "carat".     }
{             Ŀ}
{             ** NB.: SALVA I CARATTERI SOTTOSTANTI !! (con "SALVAbox") **}
{               [nella pagina video identificata dal parametro "numPAG"]  }
{               [    0 = pagina corrente, 17=pagine alternative       ]  }
{             }
{             Ŀ}
{              NB.: Per ripristinare la pagina originale usare "RECUPbox" }
{              con  gli stessi parametri utilizzati per "SALVAbox"/"Box2" }
{             }
{}
  BEGIN
    SALVAbox (ri,co,ri1,co1,numPAG);
    Box1     (ri,co,ri1,co1,txt,sfo,carat);
  END; { FINE PROCEDURE Box2 ************************************************}

{Ŀ}
  PROCEDURE    Cornice1 (rig,col,lar,alt,txt,sfo,tipo,modo:integer);       {}
{DESCRIZIONE: La procedura stampa una cornice a partire dall'angolo specifi-}
{             cato da "rig,col" (range [1,1][23,76] in  MODO standard n3);}
{             le dimensioni "lar"(lunghezza) e "alt" (altezza) sono compren-}
{             sive della cornice cio per esempio, se "rig,col"=1,1, al mas-}
{             simo [76+4=80] per [23+2=25] caratteri;i colori sono "txt" per}
{             la cornice e "sfo" per lo sfondo;il parametro "tipo" specifica}
{             l'aspetto della cornice(tipo=1=" Ŀ ",tipo=2=" ͻ ",tipo}
{             =3=" ***** ",tipo=4="  ",tipo=5="  ",tipo=6="  ")}
{             Anche se sembra inutile sottolinearlo le dimensioni della cor-}
{             nice potranno andare dalla ~minima~ "lar,alt"= 4,2 (per  altro}
{             inutile essendo costituita dalla sola cornice)  alla ~massima~}
{             "lar,alt"=80,25, praticamente un particolare  tipo  di ClrScr;}
{             il parametro "modo" indica se la cornice va  stampata  con uno}
{             spazio ai lati dei tratti verticali (modo=1) o senza (modo=0).}
{             Ŀ}
{             NB.: NON SALVA I CARATTERI SOTTOSTANTI, ma con "Salva (n)" e}
{                  "Recup (n)" pu essere assicurato anche questo servizio}
{             }
{}
  VAR n,m,w:integer;
    chr:array[1..6] of char;
  BEGIN
    CASE tipo OF
      1: chr:=('ڿĳ');
      2: chr:=('ɻȼͺ');
      3: chr:=('******');
      4: chr:=('');
      5: chr:=('');
      6: chr:=('');
    end;
    textcolor(txt);textbackground(sfo);
    gotoxy(col,rig);
    IF modo=1 THEN             {Ŀ}
    begin write(' ');w:=4; end {                                           }
    ELSE w:=2;                 {                                           }
    write(chr[1]);             {                                           }
    FOR n:=1 to lar-w do       { Stampa il  tratto superiore della cornice }
      IF (tipo=5) THEN         {(se "lar"=4 stampa " ڿ " (non esegue loop)}
         write ('')           {                                           }
      ELSE                     {  ".....Ŀ"  }
         write(chr[5]);        {                                           }
    write(chr[2]);             {                                           }
    IF modo=1 THEN write(' '); {}

    FOR m:=1 to alt-2 do       {Ŀ}
      begin                    {                                           }
        gotoxy(col,rig+m);     { Stampa il  tratto  centrale della cornice }
        IF modo=1 THEN         {    (se "alt"=2 non esegue questo loop)    }
           write(' ');         {                                           }
        write(chr[6]);         {                                           }
         FOR n:=1 to lar-w do  {                                           }
          write(' ');          {  "              .....                "  }
        write(chr[6]);         {                                           }
        IF modo=1 THEN         {                                           }
           write(' ');         {                                           }
      end;                     {}
    gotoxy(col,rig+alt-1);     {Ŀ}
    IF modo=1 THEN write(' '); {                                           }
    write(chr[3]);             {                                           }
    FOR n:=1 to (lar-w) do     { Stampa il  tratto inferiore della cornice }
      IF (tipo=5) THEN         {(se "lar"=4 stampa " ڿ " (non esegue loop)}
         write ('')           {                                           }
      ELSE                     {  "....."  }
         write(chr[5]);        {                                           }
                               {}
                                               {Ŀ}
    IF modo=1 THEN                             {                           }
    begin                                      {                           }
    write(chr[4]);                             {Queste istruzioni completa-}
    STAchr(rig+alt-1,col+lar-1,txt,sfo,' ');   {no la stampa  della cornice}
    end                                        {evitando  lo  scrolling  se}
    ELSE                                       {lar, alt = 80,25           }
    STAchr(rig+alt-1,col+lar-1,txt,sfo,chr[4]);{                           }
    gotoxy(1,1);                               {}
  END;{ FINE PROCEDURE  Cornice1 ********************************************}

{Ŀ}
  PROCEDURE    Cornice2 (rig,col,lar,alt,txt,sfo,ombP,ombS,tipo:integer)  ;{}
{DESCRIZIONE: La procedura stampa una cornice a partire dall'angolo specifi-}
{             cato da "rig,col"(range [1,1][22,74] in MODO standard n3);le}
{             dimensioni "lar" (lunghezza ) e "alt" (altezza) sono  compren-}
{             sive della cornice(esclusa ombra) cio per esempio se rig,col=}
{             1,1, al  massimo [74+4=78]  per [22+2=24]  caratteri; i colori}
{             sono "txt" per la cornice e "sfo"  per lo  sfondo; i parametri}
{             "ombP" e "ombS" specificano il colore di primo piano  e  dello}
{             sfondo da imporre ai caratteri che occupano (sotto la cornice)}
{             le posizioni adatte a creare l'effetto ombra  (da  notare che,}
{             per un effetto ombra classico, bianco su nero, i valori ideali}
{             sono  "ombP"=7  e  "ombS"=0);  il  parametro "tipo"  specifica}
{             l'aspetto della cornice(tipo=1=" Ŀ ",tipo=2=" ͻ ",tipo}
{             =3=" ***** ",tipo=4="  ",tipo=5="  ",tipo=6="  ")}
{             Anche se sembra inutile sottolinearlo le dimensioni della cor-}
{             nice potranno andare dalla ~minima~ "lar,alt"= 4,2 (per  altro}
{             inutile essendo costituita dalla sola cornice)  alla ~massima~}
{             "lar,alt"=78,24, tenuto conto della presenza dell'ombra.      }
{             Ŀ}
{             NB.: NON SALVA I CARATTERI SOTTOSTANTI, ma con "Salva (n)" e}
{                  "Recup (n)" pu essere assicurato anche questo servizio}
{             }
{}
  VAR n,m:integer;
    chr:array[1..6] of char;
  BEGIN
    CASE tipo OF
      1: chr:=('ڿĳ');
      2: chr:=('ɻȼͺ');
      3: chr:=('******');
      4: chr:=('');
      5: chr:=('');
      6: chr:=('');
    end;
    textcolor(txt);textbackground(sfo);       {Ŀ}
    gotoxy(col,rig);                          {Stampa il tratto superiore}
    write(' ',chr[1]);                        {della  cornice (se "lar"=4}
    FOR n:=1 to lar-4 do                      {stampa  " ڿ " (non esegue}
      IF (tipo=5) THEN                        {il loop)                  }
         write ('')                          {                          }
      ELSE                                    {    "....Ŀ"      }
         write(chr[5]);                       {                          }
    write(chr[2],' ');                        {}
    FOR m:=1 to alt-2 do                      {Ŀ}
      begin                                   {     Stampa il tratto     }
        gotoxy(col,rig+m);                    {         centrale         }
        write(' ',chr[6]);                    {       della cornice      }
        FOR n:=1 to lar-4 do                  {     con l'ombra di due   }
          write(' ');                         {          caratteri       }
        write(chr[6],' ');                    {       posta a destra     }
        Attrchr(rig+m,lar+col,  ombP,ombS);   {    "            "    }
        Attrchr(rig+m,lar+col+1,ombP,ombS);   {                          }
      end;                                    {}
    gotoxy(col,rig+alt-1);                    {Ŀ}
    write(' ',chr[3]);                        {     Stampa il tratto     }
    FOR n:=1 to (lar-4) do                    {         inferiore        }
      IF (tipo=5) THEN                        {       della cornice      }
         write ('')                          {     con l'ombra di un    }
      ELSE                                    {          carattere       }
         write(chr[5]);                       {        posta   sotto     }
    write(chr[4]);                            {                          }
    STAchr(rig+alt-1,col+lar-1,txt,sfo,' ');  {                          }
    IF lar<80 THEN                            {                          }
      Attrchr(rig+alt-1,lar+col,  ombP,ombS); {    ""   }
    IF lar<79 THEN                            {                          }
    Attrchr(rig+alt-1,lar+col+1,ombP,ombS);   {}
                                              {Ŀ}
    IF lar=79 THEN lar:=lar-1;                {     Stampa l'ombra       }
    IF lar=80 THEN lar:=lar-2;                {       sottostante        }
    FOR n:=1 to (lar) do                      {                          }
      Attrchr (rig+alt,col+n+1, ombP,ombS);   {    ""     }
                                              {}
  END; { FINE PROCEDURE Cornice2 ********************************************}

{Ŀ}
  PROCEDURE    Cornice3 (rig,col,lar,alt,txt,sfo,ombP,ombS,tipo:integer   ;{}
                                                         numPAG:byte)     ;{}
{DESCRIZIONE: La procedura stampa una cornice a partire dall'angolo specifi-}
{             cato da "rig,col" (range [1,1][22,74] in  MODO standard n3);}
{             le dimensioni "lar"(lunghezza ) e "alt"(altezza) sono compren-}
{             sive della cornice(esclusa ombra) cio per esempio se rig,col=}
{             1,1, al massimo [76+4=78] per [22+2=24]  caratteri;  i  colori}
{             sono "txt" per la cornice e "sfo" per lo sfondo;  i  parametri}
{             "ombP" e "ombS" specificano il colore di primo piano  e  dello}
{             sfondo da imporre ai caratteri che occupano (sotto la cornice)}
{             le posizioni adatte a creare l'effetto ombra  (da  notare che,}
{             per un effetto ombra classico, bianco su nero, i valori ideali}
{             sono  "ombP"=7  e  "ombS"=0);  il  parametro "tipo"  specifica}
{             l'aspetto della cornice(tipo=1=" Ŀ ",tipo=2=" ͻ ",tipo}
{             =3=" ***** ",tipo=4="  ",tipo=5="  ",tipo=6="  ")}
{             Anche se sembra inutile sottolinearlo le dimensioni della cor-}
{             nice potranno andare dalla ~minima~ "lar,alt"= 4,2 (per  altro}
{             inutile essendo costituita dalla sola cornice)  alla ~massima~}
{             "lar,alt"=78,24, tenuto conto della presenza dell'ombra.      }
{             Ŀ}
{             ** NB.: SALVA I CARATTERI SOTTOSTANTI !! (con "SALVAbox") **}
{               [nella pagina video identificata dal parametro "numPAG"]  }
{               [    0 = pagina corrente, 17=pagine alternative       ]  }
{             }
{             Ŀ}
{             NB.: Per ripristinare la pagina originale  usare "RECUPcorn"}
{                  con  gli  stessi  parametri  utilizzati per  "Cornice3"}
{             }
{}
  BEGIN
    SALVAbox (rig,col,rig+alt,col+lar+1,numPAG);
    Cornice2 (rig,col,lar,alt,txt,sfo,ombP,ombS,tipo);
  END; { FINE PROCEDURE Cornice3 *******************************************}

{Ŀ}
  PROCEDURE    RECUPcorn (rig,col,lar,alt:integer;numPAG:byte)            ;{}
{DESCRIZIONE: La procedura consente di recuperare completamente  tutti i ca-}
{             ratteri (e rispettivi attributi di colore) contenuti nell'area}
{             a partire dall'angolo "rig,col",  larga "lar+3" e alta "alt+1"}
{             (per tener conto anche dei caratteri  coperti  dall'ombra); si}
{             tratta di una versione di "RECUPbox"  DEDICATA  alla  gestione}
{             delle cornici: le coppie di bytes  corrispondenti  vengono co-}
{             piate nella pagina video corrente da  quella  identificata dal}
{             parametro "numPAG" (0=pagina corrente, 17=pagine alternative)}
{             annullando l'mmagine prodotta in precedenza da "Cornice3".    }
{}
  BEGIN
    RECUPbox (rig,col,rig+alt,col+lar+1,numPAG);
  END; { FINE PROCEDURE RECUPcorn  ******************************************}

{Ŀ}
 PROCEDURE  Cornice4 (rig,col,lar,alt,txt,sfo,ombP,ombS,tipo:integer;ombC:char)   ;
{DESCRIZIONE: La procedura stampa una cornice a partire dall'angolo specifi-}
{             cato da "rig,col"(range [1,1][22,74] in MODO standard n3);le}
{             dimensioni "lar"(lunghezza ) e "alt"(altezza) sono  comprensi-}
{             ve della cornice (esclusa ombra) cio per esempio  se rig,col=}
{             1,1, al massimo [76+4=78] per [22+2=24]  caratteri;  i colori:}
{             "txt" per la cornice e "sfo" per lo sfondo; a differenza della}
{             PROCEDURA "Cornice2" crea un'effetto ombra artificiale, sosti-}
{             tuendo tutti i caratteri  che occupano (sotto  la  cornice) le}
{             posizioni adatte a creare  l'effetto  ombra  con  il carattere}
{             "ombC", proposto nel colore di primo piano "txt" e con  sfondo}
{             "ombS"; il  parametro "tipo" specifica  ancora l'aspetto della}
{             l'aspetto della cornice(tipo=1=" Ŀ ",tipo=2=" ͻ ",tipo}
{             =3=" ***** ",tipo=4="  ",tipo=5="  ",tipo=6="  ")}
{             Anche se sembra inutile sottolinearlo le dimensioni della cor-}
{             nice potranno andare dalla ~minima~ "lar,alt"= 4,2 (per  altro}
{             inutile essendo costituita dalla sola cornice)  alla ~massima~}
{             "lar,alt"=78,24, tenuto conto della presenza dell'ombra.      }
{             Ŀ}
{             NB.: NON SALVA I CARATTERI SOTTOSTANTI, ma con "Salva (n)" e}
{                  "Recup (n)" pu essere assicurato anche questo servizio}
{             }
{}
  VAR n,m:integer;
      chr:array[1..6] of char;
  BEGIN
    CASE tipo OF
      1: chr:=('ڿĳ');
      2: chr:=('ɻȼͺ');
      3: chr:=('******');
      4: chr:=('');
      5: chr:=('');
      6: chr:=('');
    end;
    textcolor(txt);textbackground(sfo);
    gotoxy(col,rig);
    write(' ',chr[1]);         {Ŀ}
    FOR n:=1 to lar-4 do       { Stampa il  tratto superiore della cornice }
      IF (tipo=5) THEN         {                                           }
         write ('')           {                                           }
      ELSE                     { ".....Ŀ"   }
         write(chr[5]);        {                                           }
    write(chr[2],' ');         {}
    FOR m:=1 to alt-2 do       {Ŀ}
      begin                    {                                           }
        gotoxy(col,rig+m);     {                                           }
        write(' ',chr[6]);     {                                           }
        FOR n:=1 to lar-4 do   {Stampa il  tratto  centrale  della  cornice}
          write(' ');          {con l'ombra di due caratteri posta a destra}
        write(chr[6],' ');     {                                           }
        textbackground(ombS);  { "                                   " }
        textcolor (ombP);      {                                           }
          write(ombC,ombC);    {                                           }
        textbackground(sfo);   {                                           }
        textcolor (txt);       {                                           }
      end;                     {}
    gotoxy(col,rig+alt-1);     {Ŀ}
    write(' ',chr[3]);         {                                           }
    FOR n:=1 to lar-4 do       {Stampa il  tratto  inferiore della  cornice}
      IF (tipo=5) THEN         {  con l'ombra di un carattere posta sotto  }
         write ('')           {                                           }
      ELSE                     {                                           }
         write(chr[5]);        {                                           }
    write(chr[4]);             { "" }
    STAchr(rig+alt-1,lar+col-1,{                                           }
                  txt,sfo,' ');{                                           }
    IF lar<80 THEN             {                                           }
      STAchr(rig+alt-1,lar+    {                                           }
           col,ombP,ombS,ombC);{                                           }
    IF lar<79 THEN             {                                           }
      STAchr(rig+alt-1,lar+    {                                           }
         col+1,ombP,ombS,ombC);{}
    gotoxy(col+2,rig+alt);     {Ŀ}
    IF lar=79 THEN lar:=lar-1; {  Stampa  l'ombra di  un  carattere  posta }
    IF lar=80 THEN lar:=lar-2; {  sotto la cornice                         }
    FOR n:=1 to (lar) do       { " " }
      STAchr(rig+alt,col+n+1,  { " " }
               ombP,ombS,ombC);{                                           }
    gotoxy(1,1);               {}
  END; { FINE PROCEDURE Cornice4 ********************************************}

{Ŀ}
  PROCEDURE    Cornice5 (rig,lar,alt,txt,sfo,tipo,modo:integer);           {}
{DESCRIZIONE: La procedura stampa una cornice AUTOCENTRANTE a partire  dalla}
{             riga "rig" (range 125);  una variante a "Cornice1",  di  cui}
{             comunque si serve; le dimensioni "lar"(lunghezza) e "alt" (al-}
{             tezza) sono comprensive della cornice; i colori sono "txt" per}
{             la cornice e "sfo" per lo sfondo;il parametro "tipo" specifica}
{             l'aspetto della cornice(tipo=1=" Ŀ ",tipo=2=" ͻ ",tipo}
{             =3=" ***** ",tipo=4="  ",tipo=5="  ",tipo=6="  ")}
{             Anche se sembra inutile sottolinearlo le dimensioni della cor-}
{             nice potranno andare dalla ~minima~ "lar,alt"= 4,2 (per  altro}
{             inutile essendo costituita dalla sola cornice)  alla ~massima~}
{             "lar,alt"=80,25, praticamente un particolare  tipo  di ClrScr;}
{             il parametro "modo" indica se la cornice va  stampata  con uno}
{             spazio ai lati dei tratti verticali (modo=1) o senza (modo=0).}
{             Ŀ}
{             NB.: NON SALVA I CARATTERI SOTTOSTANTI, ma con "Salva (n)" e}
{                  "Recup (n)" pu essere assicurato anche questo servizio}
{             }
{}
 VAR col:integer;
 BEGIN
   textcolor (txt); textbackground(sfo);
   col:= (80-lar) div 2;
   col:=col+1;
   Cornice1 (rig,col,lar,alt,txt,sfo,tipo,modo);
 END;{ FINE PROCEDURE Cornice5 **********************************************}

{Ŀ}
  PROCEDURE    Riempi1 (sfo,txt:integer;carat:char)                       ;{}
{DESCRIZIONE: La procedura riempie tutta  la  pagina video (25*80 caratteri)}
{             con il carattere "carat", nel colore di primo piano "txt" e di}
{             sfondo "sfo" (realizzando un "ClrScr" personalizzato)         }
{}
  VAR n:integer;
  BEGIN
    textcolor(txt);textbackground(sfo);
    gotoxy(1,1);
    FOR n:=1 to 25*80-1 do
         write(carat);
                                  {Ŀ}
    STAchr (25,80,txt,sfo,carat); {  Queste   istruzioni   completano  la  }
    gotoxy(1,1);                  {  stampa del piano di lavoro, evitando  }
                                  {  lo scrolling del video di  una  riga  }
                                  {}
  END; { FINE PROCEDURE Riempi1 **********************************************}

{Ŀ}
  PROCEDURE    Riempi2 (sfo,txt,tipo:integer)                             ;{}
{DESCRIZIONE: La procedura riempie tutta  la  pagina video (25*80 caratteri)}
{             con un carattere ASCII predeterminato nel colore di primo pia-}
{             no "txt" e di sfondo "sfo"; il parametro "tipo"  indica  quale}
{             carattere sar utilizzato:tipo=1:chr(176)='',tipo=2:chr(177)=}
{             ='',tipo=3:chr(178)='',tipo=4:chr(219)='', tipo=5:chr( 42)=}
{             ='*',tipo=6:chr(35)='#',tipo=7:chr(2)='', tipo=8:chr(237)=''}
{             (si realizza cos un "ClrScr" personalizzato)                 }
{}
  VAR n:integer;
      chr:char;
  BEGIN
    CASE tipo OF
      1: chr:=('');
      2: chr:=('');
      3: chr:=('');
      4: chr:=('');
      5: chr:=('*');
      6: chr:=('#');
      7: chr:=('');
      8: chr:=('');
    end;
    Riempi1 (sfo,txt,chr);
  END; { FINE PROCEDURE Riempi **********************************************}

{Ŀ}
  PROCEDURE    Riempi3 (rigI,rigF,txt,sfo:byte;carat:char)                ;{}
{DESCRIZIONE: La procedura scritta in linguaggio macchina per  8086 consente}
{             di stampare una o pi righe  di  caratteri "carat" (almeno 80)}
{             nel colore  di  primo piano "txt" e di sfondo "sfo"; la stampa}
{             viene iniziata dalla colonna 1 della riga "rigI" e termina con}
{             il carattere 80 della riga "rigF"; se "rigI" e "rigF"  coinci-}
{             dono viene stampata una  riga  completa  di  80  caratteri; se}
{             "rigI"=1 e "rigF"=25  si  realizza  un "ClrScr" personalizzato}
{             analogo a quello assicurato da "Riempi1 (sfo,txt,carat)".     }
{}
  VAR
    indirizzo,quanti:word;
  BEGIN
    indirizzo:=(rigI-1)*160;
    quanti:=(rigF-rigI+1)*80;
    asm
       PUSH    ES
       PUSH    DI
       PUSH    BX
       PUSH    CX
       MOV     AX,0B800H
       MOV     ES,AX
       MOV     DI,indirizzo
       MOV     AL,carat
       MOV     BH,sfo
       SHL     BH,1
       SHL     BH,1
       SHL     BH,1
       SHL     BH,1
       MOV     BL,txt
       OR      BH,BL
       MOV     AH,BH
       MOV     CX,quanti
 @@1:  MOV     ES:[DI],AX
       INC     DI
       INC     DI
       LOOP    @@1
       POP     CX
       POP     BX
       POP     DI
       POP     ES
    end;
  END; { FINE PROCEDURA RIEMPI3 *********************************************}

{Ŀ}
  PROCEDURE  Esplosione (ritardo,lar,alt,txt,sfo,tipo:integer;numPAG:byte);{}
{DESCRIZIONE: La procedura stampa AL CENTRO dello schermo una cornice di ti-}
{             po "Cornice1" con effetto ~ESPLOSIONE~, controllabile specifi-}
{             cando il "ritardo" tra un passo e il successivo; il  numero di}
{             passi eseguiti (cio di cornici stampate)   tanto  pi grande}
{             quanto maggiore  la dimensione della cornice; e, naturalmente}
{             anche il tempo necessario per completare il servizio    tanto}
{             maggiore all'aumentare delle dimensioni: nella stampa di  cor-}
{             nici concentriche si pu valutare  che  quelle  interne  siano}
{             stampate in un tempo quattro volte pi veloce rispetto a quel-}
{             le esterne come mostra il primo parametro del seguente esempio}
{             Ŀ}
{                         Esplosione ( 1,80,25,15,7,2,1);                }
{                         Esplosione ( 4,76,23,14,6,1,1);                }
{                         Esplosione ( 8,72,21,13,5,1,1);                }
{                         Esplosione (12,68,19,12,4,1,1);                }
{                         Esplosione (16,64,17,11,3,1,1);                }
{                         Esplosione (20,60,15,10,2,1,1);                }
{                         Esplosione (24,56,13, 9,1,1,1);                }
{                         Esplosione (28,52,11, 8,0,1,1);                }
{                         Esplosione (32,48,09, 7,1,1,1);                }
{                         Esplosione (36,44,07, 6,2,1,1);                }
{                         Esplosione (40,40,05, 5,3,1,1);                }
{                         Esplosione (44,36,03, 4,1,1,1);                }
{             }
{             Il parametro "ritardo" deve essere specificato in accordo con}
{             le caratteristiche della procedura "Delay2"  che lo realizza,}
{             cio ogni numero produce un ritardo di 1 millisecondo.       }
{                                                                           }
{             La cornice finale  occuper  un'area  centrale  di dimensioni}
{             "lar" (lunghezza) e "alt" (altezza), comprensive della cornice}
{             stessa; i colori sono "txt","sfo" per cornice e sfondo, mentre}
{             il parametro "tipo" specifica l'aspetto della cornice (tipo=1=}
{             " Ŀ ", tipo=2=" ͻ ", tipo=3=" **** ", tipo=4="  ",}
{             tipo=5="  ",tipo=6="  ".                               }
{             Anche se sembra inutile sottolinearlo le dimensioni della cor-}
{             nice potranno andare dalla ~minima~ "lar,alt"= 4,2 (per  altro}
{             inutile essendo costituita dalla sola cornice)  alla ~massima~}
{             "lar,alt"=80,25, praticamente un ClrScr con effetto ESPLOSIONE}
{             Ŀ}
{             NB.: SALVA I CARATTERI SOTTOSTANTI nella  pagina alternativa}
{                  indicata dal parametro "numPAG"                        }
{             }
{}
  VAR n,ri,co,ri1,co1,rig1,col1,lar1,alt1:integer;
  BEGIN
    ri :=((25-alt) DIV 2)+1;                   {Ŀ}
    co :=((80-lar) DIV 2);                     {                          }
    co1:=co+lar;                               {Salva l'area coperta dalla}
    ri1:=ri+alt-1;                             {Cornice esterna           }
    SALVAbox (ri,co,ri1,co1,numPAG);           {                          }
                                               {}
    n:=0;
    REPEAT
      lar1:=4+2*n;
      IF   lar1 > lar THEN lar1:= lar
      ELSE col1:= 39-n;
      IF   col1<1 THEN col1:=1;

      alt1:=2+2*n;
      IF   alt1 > alt THEN alt1:= alt
      ELSE rig1:= 12-n;
      IF   rig1 <  1 THEN rig1:=1;

      Cornice1 (rig1,col1,lar1,alt1,txt,sfo,tipo,1);
      n:=n+1;
      delay2 (ritardo);

    UNTIL (lar1=lar) and (alt1=alt);
  END; { FINE PROCEDURE Esplosione ******************************************}

{Ŀ}
  PROCEDURE   PreImplos  (rig,col,lar,alt,txt,sfo:integer;numPAG:byte);    {}
{DESCRIZIONE: La procedura prepara la  chiamata della "Implosione" salvando}
{             l'area che verr coperta dalla finestra  da  essa  scritta in}
{             una pagina Video  alternativa  indicata da "numPAG"; natural-}
{             mente le coordinate, le dimensioni e i colori  da  dichiarare}
{             attraverso i parametri (rig,col,lar,alt,txt,sfo,tipo)  devono}
{             essere gli stessi poi dichiarati da "Implosione"             }
{}
  BEGIN
   {SALVAbox (ri , co,   ri1   ,   co1   ,numPAG);}{Ŀ}
    SALVAbox (rig,col,alt+rig-1,lar+col-1,numPAG); {Salva lo spazio sotto}
    Cornice1 (rig,col,lar,alt,txt,sfo,1,1);        {}
  END; { FINE PROCEDURE PreImplosione ***************************************}

{Ŀ}
  PROCEDURE   Implosione (ritardo,rig,col,lar,alt,sfo:integer;numPAG:byte);{}
{DESCRIZIONE: La procedura recupera i caratteri  sottostanti  alla  Cornice}
{             precedentemente  stampata  con "PreImplos"  nella   posizione}
{             e con le dimensioni IDENTICHE a quelle passate come parametri}
{             a questa procedura; l'effetto Implosione   ottenuto  recupe-}
{             rando i caratteri dalla pagina alternativa con  una  serie di}
{             "finestre" sempre pi piccole; la  velocit tra un passo e il}
{             successivo  controllabile col parametro "ritardo".          }
{             Naturalmente il numero di passi eseguiti (cio di box recupe-}
{             rati)  tanto pi grande quanto maggiore  la dimensione ini-}
{             ziale della cornice;                                         }
{             Ŀ}
{             NB.:Per garantire il suo funzionamento si avvale di un par-}
{                 ticolare codice in ASSEMBLER che consente di recuperare}
{                 uno strato esterno della dimensione  di  un  carattere,}
{                 ogni volta che viene attivato; il recupero avviene dal-}
{                 la pagina Video alternativa identificata dal  parametro}
{                 "numPAG" (0=pagina corrente,  17= pagine alternative).}
{             ٳ}
{             Il parametro "ritardo" deve essere specificato in accordo con}
{             le caratteristiche della procedura "Delay2"  che lo realizza,}
{             cio ogni numero produce un ritardo di 1 millisecondo.       }
{                                                                          }
{             Viene ora fornito un esempio di uso corretto  della procedura}
{             "Implosione" per aprire  una  cornice  di tipo "Cornice1" con}
{             parametri (rig,col,lar,alt,txt,sfo,tipo) in Modo 1 (cio  con}
{             uno spazio sia a destra che a sinistra  del  lato verticale):}
{               Ŀ  }
{               PreImplos  (        rig ,col,lar,alt,txt,sfo,numPAG);    }
{               gotoxy     (       rig+1,col+1);                         }
{               write      (' ... messaggio ... ');                      }
{               tasto:=readkey;                                          }
{               Implosione (ritardo,rig ,col,lar,alt    ,sfo,numPAG);    }
{                 .....                                                  }
{                 }
{}
  VAR indirizzo:word;
      finito:boolean;
  BEGIN
    finito:=false;
    Box1 (rig,col,rig+alt-1,col+lar-1,7,sfo,' ');
    REPEAT
      indirizzo:=(col-1)*2+(rig-1)*160;
      IF alt=1 THEN
      begin
        finito:=true;
        asm                      {Ŀ}
          PUSH    ES             {    Elimina l'ultima eventuale riga      }
          PUSH    DI             {    centrale del box                     }
          PUSH    SI             {                                         }
          PUSH    CX             {                                         }
          PUSH    DX             {                                         }
          MOV     AX,0B800H      {                                         }
          MOV     ES,AX          {                                         }
          MOV     CL,numPAG      {                                         }
          MOV     CH,00H         {                                         }
          MOV     AX,1000H       {                                         }
          MUL     CX             {                                         }
          MOV     SI,AX          {                                         }
          ADD     SI,indirizzo   {                                         }
          MOV     DI,indirizzo   {                                         }
          MOV     CX,lar         {                                         }
          INC     CX             {                                         }
      @@4:MOV     AX,ES:[SI]     {                                         }
          MOV     ES:[DI],AX     {                                         }
          INC     DI             {                                         }
          INC     DI             {                                         }
          INC     SI             {                                         }
          INC     SI             {                                         }
          LOOP    @@4            {                                         }
          POP     DX             {                                         }
          POP     CX             {                                         }
          POP     SI             {                                         }
          POP     DI             {                                         }
          POP     ES             {                                         }
        end;                     {}
      end
      ELSE IF alt=2 THEN
      begin
        finito:=true;
        asm                      {Ŀ}
          PUSH    ES             {    Elimina le eventuali ultime due righe}
          PUSH    DI             {    centrali del box                     }
          PUSH    SI             {                                         }
          PUSH    CX             {                                         }
          PUSH    DX             {                                         }
          MOV     AX,0B800H      {                                         }
          MOV     ES,AX          {                                         }
          MOV     CL,numPAG      {                                         }
          MOV     CH,00H         {                                         }
          MOV     AX,1000H       {                                         }
          MUL     CX             {                                         }
          MOV     SI,AX          {                                         }
          ADD     SI,indirizzo   {                                         }
          MOV     DI,indirizzo   {                                         }
          MOV     CX,lar         {                                         }
          INC     CX             {                                         }
          PUSH    DI             {                                         }
          PUSH    SI             {                                         }
          PUSH    CX             {                                         }
      @@5:MOV     AX,ES:[SI]     {                                         }
          MOV     ES:[DI],AX     {                                         }
          INC     DI             {                                         }
          INC     DI             {                                         }
          INC     SI             {                                         }
          INC     SI             {                                         }
          LOOP    @@5            {                                         }
          POP     CX             {                                         }
          POP     SI             {                                         }
          POP     DI             {                                         }
          MOV     AX,00A0H       {                                         }
          ADD     SI,AX          {                                         }
          ADD     DI,AX          {                                         }
      @@6:MOV     AX,ES:[SI]     {                                         }
          MOV     ES:[DI],AX     {                                         }
          INC     DI             {                                         }
          INC     DI             {                                         }
          INC     SI             {                                         }
          INC     SI             {                                         }
          LOOP    @@6            {                                         }
          POP     DX             {                                         }
          POP     CX             {                                         }
          POP     SI             {                                         }
          POP     DI             {                                         }
          POP     ES             {                                         }
        end;                     {}
      end
      ELSE
        asm                      {Ŀ}
          PUSH    ES             {    Elimina lo strato esterno di ciascun }
          PUSH    DI             {    box precedentemente posto a video    }
          PUSH    SI             {                                         }
          PUSH    BX             {                                         }
          PUSH    CX             {                                         }
          PUSH    DX             {                                         }
          MOV     AX,0B800H      {                                         }
          MOV     ES,AX          {                                         }
          MOV     CL,numPAG      {                                         }
          MOV     CH,00H         {                                         }
          MOV     AX,1000H       {                                         }
          MUL     CX             {                                         }
          MOV     SI,AX          {                                         }
          ADD     SI,indirizzo   {                                         }
          PUSH    SI             {                                         }
          MOV     DI,indirizzo   {                                         }
          MOV     CX,lar         {                                         }
      @@1:MOV     AX,ES:[SI]     {                                         }
          MOV     ES:[DI],AX     {                                         }
          INC     DI             {                                         }
          INC     DI             {                                         }
          INC     SI             {                                         }
          INC     SI             {                                         }
          LOOP    @@1            {                                         }
          MOV     BX,0001H       {                                         }
          MOV     CX,alt         {                                         }
          SUB     CX,0002H       {                                         }
      @@2:MOV     DI,indirizzo   {                                         }
          POP     SI             {                                         }
          PUSH    SI             {                                         }
          MOV     AX,00A0H       {                                         }
          MUL     BX             {                                         }
          ADD     SI,AX          {                                         }
          ADD     DI,AX          {                                         }
          MOV     AX,ES:[SI]     {                                         }
          MOV     ES:[DI],AX     {                                         }
          PUSH    CX             {                                         }
          MOV     AX,0002H       {                                         }
          MOV     CX,lar         {                                         }
          SUB     CX,0001H       {                                         }
          MUL     CX             {                                         }
          ADD     SI,AX          {                                         }
          ADD     DI,AX          {                                         }
          POP     CX             {                                         }
          MOV     AX,ES:[SI]     {                                         }
          MOV     ES:[DI],AX     {                                         }
          INC     BX             {                                         }
          LOOP    @@2            {                                         }
          MOV     DI,indirizzo   {                                         }
          POP     SI             {                                         }
          MOV     BX,alt         {                                         }
          SUB     BX,0001H       {                                         }
          MOV     AX,00A0H       {                                         }
          MUL     BX             {                                         }
          ADD     SI,AX          {                                         }
          ADD     DI,AX          {                                         }
          MOV     CX,lar         {                                         }
      @@3:MOV     AX,ES:[SI]     {                                         }
          MOV     ES:[DI],AX     {                                         }
          INC     DI             {                                         }
          INC     DI             {                                         }
          INC     SI             {                                         }
          INC     SI             {                                         }
          LOOP    @@3            {                                         }
          POP     DX             {                                         }
          POP     CX             {                                         }
          POP     BX             {                                         }
          POP     SI             {                                         }
          POP     DI             {                                         }
          POP     ES             {                                         }
        end;                     {}
      rig:=rig+1;
      col:=col+1;
      lar:=lar-2; IF lar<1 THEN lar:= 1;
      alt:=alt-2; IF alt<1 THEN alt:= 1;
      delay2 (ritardo);
    UNTIL finito;
  END; { FINE PROCEDURE Implosione ******************************************}

{Ŀ}
  PROCEDURE   Anykey                                                      ;{}
{DESCRIZIONE:La procedura stampa in posizione fissa, nella parte bassa del-}
{            lo schermo, la frase "Premere un tasto per continuare" e rima-}
{            ne in attesa della pressione di un tasto: il valore ASCII  del}
{            tasto premuto   lasciato nella variabile di sistema "readkey"}
{            che pu essere letta dal programma chiamante; questa procedura}
{            costituisce un valido esempio di presentazione  di messaggi in}
{            cornici di tipo "Cornice1",in grado di salvare l'immagine sot-}
{            tostante (con "SALVAbox") e recuperarla con effetto implosione}
{            (mediante, appunto "Implosione")                              }
{            Non recupera la visualizzazione del Cursore                   }
{}
  BEGIN
    VIAcur;
   {SALVAbox   (        rig,col,alt+rig-1,lar+col-1        ,numPAG);}
    SALVAbox   (         21, 6 ,      23 ,75               , 1    );
   {Cornice1   (        rig,col,      lar,alt      ,txt,sfo, tipo,modo );}
    Cornice1   (         21, 6 ,      70 , 3       , 4, 0  , 1   , 1   );

    textcolor(15);textbackground(1);
    gotoxy ( 8,22); write('            Premere un tasto qualunque per continuare             ');
    REPEAT UNTIL keypressed;

   {Implosione (ritardo,rig,col,      lar,alt      ,    sfo,numPAG);}
    Implosione (  100  , 21, 6 ,      70 , 3       ,     0 , 1    );

  END; { FINE PROCEDURE Anykey **********************************************}

{Ŀ}
  PROCEDURE AspettaKeyClick (VAR tasto:char; VAR pulsante:word);           {}
{DESCRIZIONE:La procedura si limita a fermare il programma in attesa della }
{            pressione di un tasto o del click di uno qualunque dei tasti  }
{            del mouse: il valore ASCII del tasto premuto  lasciato nella }
{            variabile di sistema "readkey" che pu essere letta dal pro-  }
{            gramma chiamante.                                             }
{            NB: lascia nella prima variabile il codice  Ascii  del  tasto }
{            premuto (se  premuto un tasto) e nella seconda il numero del }
{            pulsante del mouse (se si  fatto click con il mouse, per la  }
{            decodifica del numero consultare "pulMou"                     }
{}
 BEGIN
    REPEAT UNTIL (keypressed) OR (pulMou<>0);
    IF keypressed THEN tasto:=readkey;
    IF pulMou<>0  THEN pulsante:=pulMou;
    REPEAT UNTIL pulMou=0;  {aspetta il rilascio del pulsante del Mouse}
 END; { FINE PROCEDURE AspettaKeyClick *************************************}

{Ŀ}
  PROCEDURE KeyClickMessage1 (VAR tasto:char; VAR pulsante:word;           {}
                                        txt,sfo:integer;testo1:string);    {}
{DESCRIZIONE:La procedura ferma il programma in attesa della pressione di  }
{            un tasto o del click di uno qualunque dei tasti del mouse: il }
{            valore ASCII del tasto premuto  lasciato nella variabile di  }
{            sistema "readkey" che pu essere letta dal programma chiaman- }
{            te. Mentre attende mostra il messaggio;                       }
{            'Muovi il mouse - premi un tasto o fai click per '+ testo1    }
{            sull'ultima riga in fondo, a partire dalla colonna  5, in co- }
{            lore "txt" su sfondo "sfo", ed aggiunge subito dopo la stringa}
{            passata dal parametro "testo1"                                }
{            NB: lascia nella prima variabile il codice  Ascii  del  tasto }
{            premuto (se  premuto un tasto) e nella seconda il numero del }
{            pulsante del mouse (se si  fatto click con il mouse, per la  }
{            decodifica del numero consultare "pulMou"                     }
{}
 BEGIN
   Riempi3 (25,25,txt,sfo,' ');
   textbackground(sfo);textcolor(txt);
   gotoxy (5,25); write('Muovi il mouse - premi un tasto o fai click per '+testo1);
   AspettaKeyClick (tasto,pulsante);
 END;

{Ŀ}
  PROCEDURE KeyClickMessage2 (VAR tasto:char; VAR pulsante:word;           {}
                                        txt,sfo:integer;testo1:string);    {}
{DESCRIZIONE:La procedura ferma il programma in attesa della pressione di  }
{            un tasto o del click di uno qualunque dei tasti del mouse: il }
{            valore ASCII del tasto premuto  lasciato nella variabile di  }
{            sistema "readkey" che pu essere letta dal programma chiaman- }
{            te. Mentre attende mostra il messaggio;                       }
{                   'Premi un tasto o fai click per '+ testo1              }
{            sull'ultima riga in fondo, a partire dalla colonna 22, in co- }
{            lore "txt" su sfondo "sfo", ed aggiunge subito dopo la stringa}
{            passata dal parametro "testo1"                                }
{            NB: lascia nella prima variabile il codice  Ascii  del  tasto }
{            premuto (se  premuto un tasto) e nella seconda il numero del }
{            pulsante del mouse (se si  fatto click con il mouse, per la  }
{            decodifica del numero consultare "pulMou"                     }
{}
 BEGIN
   Riempi3 (25,25,txt,sfo,' ');
   textbackground(sfo);textcolor(txt);
   gotoxy (15,25); write('Premi un tasto o fai click per '+testo1);
   AspettaKeyClick (tasto,pulsante);
 END;

{Ŀ}
  PROCEDURE   CORN_DOS (colore:byte)                                      ;{}
{DESCRIZIONE:La procedura scritta in linguaggio macchina per  8086  consente}
{            di attivare la cornice esterna del video dovuta alla sovrascan-}
{            sione, nel colore passato come parametro (numero da 0 a 15) con}
{            il consueto significato,  0=nero,  1=blu,  2=verde,  3=azzurro,}
{            4=rosso, 5=magenta, 6=giallo, 7=bianco,  9  15 = stessi colori}
{            con brillantezza.                                              }
{}
 BEGIN
   asm
       PUSH    AX
       PUSH    BX
       MOV     AH,0BH      {Attiva la funzione 0BH dell'INT 10H  evidenziando}
       MOV     BH,00H      {con BH=00H che si desidera colorare la cornice di}
       MOV     BL,colore   {sovrascansione del video con il colore corrispon-}
       INT     10H         {dente al codice numerico passato  come  parametro}
       POP     BX
       POP     AX
   end;
 END; { FINE PROCEDURE CORN-DOS *********************************************}

{Ŀ}
  PROCEDURE    Data(riga,colonna,testo,sfondo,come:integer)               ;{}
{DESCRIZIONE: La procedura stampa a video, nella posizione "riga,colonna" e}
{             con il colore "testo,sfondo", la DATA  corrente, nella  forma}
{             "nomeGiorno gg/mm/aa" se [come]=0 o "gg/mm/aa" se [come]=0.  }
{}
 CONST gsett:array[0..6] of string[9] = (' Domenica','   Luned','  Marted',
                            'Mercoled','  Gioved','  Venerd','   Sabato');
 VAR
   s                         :string;
   Anno,Mese,Giorno,NomeGiorn:word;

 BEGIN
   textcolor(testo); textbackground(sfondo);
   gotoxy(colonna,riga);
   DataIN(Anno, Mese, Giorno, NomeGiorn);
   IF come=0 THEN
      write(gsett[nomeGiorn],' ');
   str(Giorno,s);
   IF length(s)=1 THEN s:='0'+s;
   write(s,'/');
   str(Mese,s);
   IF length(s)=1 THEN s:='0'+s;
   write(s,'/');
   str(Anno,s);
   IF length(s)=1 THEN s:='0'+s;
   write(s);
 END; { FINE PROCEDURE Data *************************************************}

{Ŀ}
  PROCEDURE    Ora(riga,colonna,testo,sfondo,come:integer)                ;{}
{DESCRIZIONE: La procedura stampa a video, nella posizione "riga,colonna" e}
{             con il  colore "testo,sfondo",  l'ORA  corrente, nella  forma}
{             "hh:mm:ss" se [come]=0, o "hh:mm:ss.centesimi" se [come]=1, o}
{             nella forma "hh:mm" se [come]=2.                             }
{}
 VAR
   s                           :string;
   Ora,Minuti,Secondi,Centesimi:Word;
 BEGIN
   textcolor(testo); textbackground(sfondo);
   gotoxy(colonna,riga);
   OraIN(Ora,Minuti,Secondi,Centesimi);
   str(Ora,s);
   IF length(s)=1 THEN s:='0'+s;
   write(s,':');
   str(Minuti,s);
   IF length(s)=1 THEN s:='0'+s;
   write(s);
   IF (come=0) OR (come=1) THEN
   begin
     str(Secondi,s);
     IF length(s)=1 THEN s:='0'+s;
     write(':',s);
     IF come=1 THEN
     begin
       str(Centesimi,s);
       IF length(s)=1 THEN s:='0'+s;
       write('.',s);
     end;
   end;
 END; { FINE PROCEDURE Ora **************************************************}

{Ŀ}
  PROCEDURE    SETdata (Anno,Mese,Giorno:Word)                            ;{}
{DESCRIZIONE: La procedura consente di predisporre le variabili interne del}
{             per una NUOVA DATA corrente.                                 }
{}
 BEGIN
  asm
	MOV	CX,Anno
	MOV	DH,Byte Ptr Mese
	MOV	DL,Byte Ptr Giorno
	MOV	AH,2BH
	INT	21H
  end;
 END; { FINE PROCEDURE SETdata **********************************************}

{Ŀ}
  PROCEDURE    SETora(Ora,Minuti,Secondi,Centesimi:Word)                  ;{}
{DESCRIZIONE: La procedura consente di predisporre le variabili intern  del}
{             per una NUOVA ORA  corrente.                                 }
{}
 BEGIN
  asm
	MOV	CH,Byte Ptr Ora
	MOV	CL,Byte Ptr Minuti
	MOV	DH,Byte Ptr Secondi
	MOV	DL,Byte Ptr Centesimi
	MOV	AH,2DH
	INT	21H
  end;
 END; { FINE PROCEDURE SETora ***********************************************}

{Ŀ}
  PROCEDURE   VediMouse                                                   ;{}
{DESCRIZIONE:Abilita la visualizzazione del cursore del MOUSE (se la visua-}
{            lizzazione  gi attiva questa procedura NON ha  effetto.     }
{}
 BEGIN
   asm
       PUSH    AX
       MOV     AX,0001H
       INT     33H
       POP     AX
   end;
 END; { FINE PROCEDURE VediMouse ********************************************}

{Ŀ}
  PROCEDURE   ViaMouse                                                    ;{}
{DESCRIZIONE:Disabilita la  visualizzazione  del  cursore  del  MOUSE; ogni}
{            volta che viene chiamata questa procedura DEVE in seguito es -}
{            sere chiamata la "VediMouse"  (che mostra il cursore); inoltre}
{            ogni volta che un programma cambia il modo video essa   chia-}
{            mata automaticamente.                                         }
{                                                                          }
{ATTENZIONE:  opportuno chiamare questa Procedura alla fine  di  ogni pro-}
{            gramma per cancellare il cursore del  MOUSE,  assicurando cos}
{            che nulla rimanga sullo schermo; comunque   necessario  chia-}
{            marla PRIMA di ogni cambiamento dell'immagine che  contiene il}
{            sore, per evitare visualizzazioni indesiderate.               }
{}
 BEGIN
   asm
       PUSH    AX
       MOV     AX,0002H
       INT     33H
       POP     AX
   end;
 END; { FINE PROCEDURE ViaMouse  ********************************************}

{Ŀ}
  PROCEDURE   SetMouse (pixel:boolean; colonna,riga:word)                 ;{}
{DESCRIZIONE:Procedura MOUSE che fissa la posizione del cursore  del  MOUSE}
{            al valore posto in ingresso in "riga","colonna",  direttamente}
{            in pixel nel range 0*824*8,0*879*8,0192,0632  nel consueto}
{            modo video "TESTO,03" (se "pixel"   vero) o nel classico ran-}
{            ge 125,180  se  la  variabile booleana "pixel"   prefissata}
{            falsa.                                                        }
{}
 BEGIN
 IF pixel THEN
   asm
       PUSH    AX
       PUSH    DX
       PUSH    CX
       MOV     CX,colonna
       MOV     DX,riga
       MOV     AX,0004H
       INT     33H
       POP     CX
       POP     DX
       POP     AX
   end
 ELSE
   asm
       PUSH    AX
       PUSH    DX
       PUSH    CX
       MOV     CX,colonna
       DEC     CX
       SAL     CX,1
       SAL     CX,1
       SAL     CX,1
       MOV     DX,riga
       DEC     DX
       SAL     DX,1
       SAL     DX,1
       SAL     DX,1
       MOV     AX,0004H
       INT     33H
       POP     CX
       POP     DX
       POP     AX
   end;
 END; { FINE PROCEDURE SetMouse  ********************************************}

{Ŀ}
  PROCEDURE   BoxMouse (rig1,col1,rig2,col2:word;pixel:boolean)           ;{}
{DESCRIZIONE:Procedura MOUSE che obbliga il MOUSE a  muoversi  SOLO  dentro}
{            una finestra con angolo in alto a destra (rig1,col1)  e angolo}
{            in basso a sinistra (rig2,col2); le coordinate sono  in  pixel}
{            (range 0*824*8,0*879*8,0192,0632, in modo TESTO,03") se il}
{            parametro "pixel"  VERO; altrimenti sono espresse in caratte-}
{            ri (range 125,180); dopo la chiamata della procedura il cur-}
{            sore del MOUSE  comunque forzato dentro il box.              }
{}
 BEGIN
 IF pixel THEN
   asm
       PUSH    AX
       PUSH    DX
       PUSH    CX
       MOV     CX,col1
       MOV     DX,col2
       MOV     AX,0007H
       INT     33H
       MOV     CX,rig1
       MOV     DX,rig2
       MOV     AX,0008H
       INT     33H
       POP     CX
       POP     DX
       POP     AX
   end
 ELSE
   asm
       PUSH    AX
       PUSH    DX
       PUSH    CX
       MOV     CX,col1
       DEC     CX
       SAL     CX,1
       SAL     CX,1
       SAL     CX,1
       MOV     DX,col2
       DEC     DX
       SAL     DX,1
       SAL     DX,1
       SAL     DX,1
       MOV     AX,0007H
       INT     33H
       MOV     CX,rig1
       DEC     CX
       SAL     CX,1
       SAL     CX,1
       SAL     CX,1
       MOV     DX,rig2
       DEC     DX
       SAL     DX,1
       SAL     DX,1
       SAL     DX,1
       MOV     AX,0008H
       INT     33H
       POP     CX
       POP     DX
       POP     AX
   end;
 END; { FINE PROCEDURE BoxMouse  ********************************************}

{Ŀ}
  PROCEDURE   CambiaCur1 (inizio,fine:word)                               ;{}
{DESCRIZIONE:Creazione del CURSORE in MODO TESTO HARDWARE: in  questo  caso}
{            il cursore del MOUSE NON modifica il carattere ad  esso sotto-}
{            stante ma ne genera uno analogo a quello  del  VIDEO,  cio un}
{            trattino lampeggiante di dimensioni programmabili, MODIFICANDO}
{            ANCHE QUELLO!!!; supposto che esso sia costituito da un blocco}
{            suddiviso in 16 trattini (VGA),  esso  comincer  dal trattino}
{            "inizio" (in alto) e finir con il trattino "fine" (in basso),}
{            entrambi numerati da 0 a 15 (VGA, o da 0 a 7, CGA, in funzione}
{            del tipo scheda grafica utilizzata); per esempio con "inizio"=}
{            15 e "fine"=1 viene generato un cursore lampeggiante di dimen-}
{            sioni "piene","", e con "inizio"=15 e "fine"=15 un cursore ha}
{            dimensioni "strette", "_"                                     }
{}
 BEGIN
   asm
       PUSH    AX
       PUSH    DX
       PUSH    CX
       PUSH    BX
       MOV     CX,inizio
       MOV     DX,fine
       MOV     BX,0001H
       MOV     AX,000AH
       INT     33H
       POP     BX
       POP     CX
       POP     DX
       POP     AX
   end;
 END; { FINE PROCEDURE CambiaCur1 *******************************************}

{Ŀ}
  PROCEDURE   CambiaCur2 (sfondo,colore:word)                             ;{}
{DESCRIZIONE:Creazione del CURSORE in MODO TESTO SOFTWARE: in  questo  caso}
{             possibile cambiare a piacere l'attributo di  colore  del ca-}
{            rattere posto sotto il cursore del MOUSE, in accordo con i co-}
{            lori "sfondo" e "colore" purch il loro valore sia MINORE di16}
{}
 BEGIN
   IF (sfondo<16)and(colore<16) THEN
     begin
       asm
          PUSH    AX         {****** Con  CX=FFFFH  e  DX=7700H *************}
          PUSH    BX         {Il carattere attualmente presente sotto il cur-}
          PUSH    CX         {sore viene sottoposto ad AND con il valore for-}
          PUSH    DX         {nito in CL (=FFH)  e il valore cos  ottenuto }
                             {poi sottoposto a XOR con il valore  fornito  in}
                             {DL (=00H), lasciandolo  INALTERATO; l'attributo}
          MOV     CL,8       {del carattere subisce analogamente l'AND con CH}
          MOV     AX,colore  {(FFH) e il valore cos ottenuto  trattato  con}
          SAL     AX,CL      {una XOR con DH (=77H), cosa che produce un  ef-}
          MOV     CL,12      {fetto di "INVERSE VIDEO" (ponendo il bit7 di DH}
          MOV     DX,sfondo  {a 1, DH=F7, si imporrebbe un inverse  con FLASH}
          SAL     DX,CL      {sul carattere  di "PRIMO PIANO")               }
          ADD     DX,AX
          MOV     CX,00FFH
          MOV     BX,0000H
          MOV     AX,000AH
          INT     33H
          POP     DX
          POP     CX
          POP     BX
          POP     AX
       end;
     end;
 END; { FINE PROCEDURE CambiaCur2 *******************************************}

{Ŀ}
  PROCEDURE    Delay0 (ritardo:word);                                      {}
{AUTORE     :Giorgio OBER                                                  }
{VERSIONE   :febbraio 2000                                                 }
{DESCRIZIONE:Questa procedura serve per creare un RITARDO programmabile, in}
{            funzione del valore specificato dal parametro "ritardo".      }
{            Il ritardo prodotto   completamente svincolato dalla velocit}
{            del processore, ma ha lo svantaggio di VINCOLARE  i  tempi del}
{            ritardo a multipli del tempo MINIMO di 54,925493 millisecondi.}
{                                                                          }
{             Su questa base  possibile tracciare la seguente TABELLA:    }
{ ĿĿĿĿ}
{ ritardo Delay0 ritardo Delay0 ritardo Delay0 ritardo  Delay0 }
{ ĴĴĴĴ}
{  0001    55 ms  0011   604 ms  0045   2.5 s   0920   50  s }
{  0002   110 ms  0012   659 ms  0054    3  s   1092    1  m }
{  0003   164 ms  0013   714 ms  0063   3.5 s   2294    2  m }
{  0004   219 ms  0014   769 ms  0073    4  s   3277    3  m }
{  0005   274 ms  0015   824 ms  0082   4.5 s   5462    5  m }
{  0006   329 ms  0016   879 ms  0091    5  s  10924   10  m }
{  0007   384 ms  0017   934 ms  0182   10  s  21848   20  m }
{  0008   439 ms  0018    1  s  0364   20  s  32771   30  m }
{  0009   494 ms  0027   1.5 s  0546   30  s  43695   40  m }
{  0010   549 ms  0036    2  s  0728   40  s  65536    1  h }
{ ٳ}
{}
  BEGIN
    asm
      PUSH    AX
      PUSH    BX
      PUSH    CX
      PUSH    DX
                         {Ŀ}
      MOV     CX,ritardo {Copia in BX il numero corrispondente al RITARDO}
      PUSH    CX         {desiderato passato in ingresso in "ritardo"    }
      POP     BX         {}
                         {Ŀ}
                         {Restituisce in CX:DX il  tempo  reale  corrente}
                         {del giorno assumendolo dal contenuto delle  lo-}
                         {cazioni di sistema da 0000:046C a 0000:046F, in}
                         {forma di numero a 32 bit dei TICK prodotti nel-}
                         {l'arco della giornata{ da notare che AL=00 sol}
      MOV     AH,00H     {se la mezzanotte NON  trascorsa dopo  l'ultima}
      INT     1AH        {lettura: ci consente di non incorrere in erro-}
                         {ri di valutazione quando la procedura lavora in}
                         {tempi a cavallo della mezzanotte, poich il nu-}
                         {mero a 32 bit alle 24:00 raggiunge il suo valo-}
                         {re massimo (= 18,2 *60*60*24 = 1.573.040 decim.}
                         {= 0018 00B0 Hex) dopodich VIENE AZZERATO (e AL}
                         {viene posto ad un valore DIVERSO da ZERO)      }
                         {}
                         {Ŀ}
      ADD     DX,BX      {Aggiorna il numero CX:DX dei TICK  relativi al-}
      JNC     @@0        {la prima lettura delle variabili  di sistema da}
      INC     CX         {0000:046C a 0000:046F,  con  il  numero  corri-}
                         {spondente  al  RITARDO  desiderato             }
                         {}
                         {Ŀ}
  @@0:PUSH    CX         {Copia in AX:BX il  numero dei TICK relativi al-}
      PUSH    DX         {la prima lettura delle variabili di  sistema da}
      POP     BX         {0000:046C a 0000:046F, AGGIORNATA  con il nume-}
      POP     AX         {ro  corrispondente  al  RITARDO  desiderato    }
                         {}
                         {Ŀ}
  @@1:PUSH    AX         {                                               }
      PUSH    BX         { In uscita AX:BX conservano il numero  di  TICK}
      MOV     AH,00H     { relativi alla prima lettura delle variabili di}
      INT     1AH        { sistema da 0000:046C a 0000:046F; e  in  CX:DX}
      POP     BX         { quello del tempo reale corrente               }
      POP     AX         {                                               }
                         {}
                         {Ŀ}
      CMP     AX,CX      { Ŀ                        }
      JZ      @@2        { AX=CX (AX-CX=0000)                          }
      JC      @@3        { AX<CX (AX-CX=FFFF)                          }
      JMP     @@1        { AX>CX (AX-CX=0001)                          }
  @@2:CMP     BX,DX      {                      Controlla se il valore }
      JG      @@1        { BX>DX (BX-DX>0000)   corrente dei  TICKs   }
                         {                      quello  previsto   dal }
  @@3:PUSH    AX         {                      desiderato     RITARDO }
      SUB     AX,CX      { AX<CX (AX-CX=FFE8)                          }
      CMP     AX,0FFE8H  { caso in cui CX=0018                         }
      POP     AX         { (solo a mezzamotte)                         }
      JZ      @@1        {                         }
                         {}

      POP     DX
      POP     CX
      POP     BX
      POP     AX
    end
 END; { FINE PROCEDURE Delay0 ***********************************************}

{Ŀ}
  PROCEDURE    Delay1 (ritardo:longint);                                   {}
{AUTORE     :Giorgio OBER                                                  }
{VERSIONE   :febbraio 2000                                                 }
{DESCRIZIONE:Questa procedura serve per creare un RITARDO programmabile, in}
{            funzione del valore specificato dal parametro "ritardo".      }
{            Il ritardo prodotto   completamente svincolato dalla velocit}
{            del processore; i tempi del ritardo a multipli del tempo MINI-}
{            MO di 0,976 microsecondi, cio circa 1 microsecondo.          }
{                                                                          }
{            Su questa base  possibile tracciare la seguente TABELLA:     }
{Ŀ}
{rit.Delay1 rit.Delay1ritardoDelay1 ritardoDelay1  ritardoDelay1}
{Ĵ}
{  1  1 s 1024  1 ms 102459 100ms 1024590  1  s 61475410  1  m
{  2  2 s 2049  2 ms 204918 200ms 2049180  2  s122950829  2  m}
{  3  3 s 3074  3 ms 307377 300ms 3073770  3  s184426230  3  m}
{  4  4 s 4098  4 ms 409836 400ms 4098360  4  s245901639  4  m}
{  5  5 s 5123  5 ms 512295 500ms 5122951  5  s307377049  5  m}
{  6  6 s 6148  6 ms 614754 600ms 6147541  6  s368852459  6  m}
{  7  7 s 7172  7 ms 717213 700ms 7172131  7  s430327869  7  m}
{  8  8 s 8197  8 ms 819672 800ms 8196721  8  s491803279  8  m}
{  9  9 s 9221  9 ms 922131 900ms 9221311  9  s553278689  9  m}
{ 10 10 s10246 10 ms1024590  1  s10245901 10  s614754098 10  m}
{ٳ}
{            Per curiosit il valore massimo  per  il parametro "ritardo" }
{            corrisponde al pi grande numero binario  possibile  a 32 bit,}
{            cio: 2^32 = 4294967296;  se  ricordiamo  che  ciascuna  unit}
{            introduce un ritardo di 967ns (circa 1 s),  se  "ritardo"  ha}
{            questo valore il ritardo introdotto  sar di 4191888081000 ns,}
{            pari a 4191888081 s, pari a 4191888 ms, pari a 4192 s, cio  }
{            poco meno di 69 minuti, circa 1 ora e 9 minuti!!              }
{}
 VAR  NumHi,NumLo:word;
 BEGIN
   NumHi:=ritardo   DIV   65536; { CX = Risultato intero della divisione    }
   NumLo:=ritardo - NumHi*65536; { DX = Parte rimanente del numero "ritardo"}
    asm
      PUSH    AX
      PUSH    CX
      PUSH    DX
                        {Ŀ}
      MOV     CX,NumHi  {Prepara in CX,DX  i valori corrispondenti al nu-}
      MOV     DX,NumLo  {mero desiderato passato in ingresso in "ritardo"}
                        {}
      MOV     AH,86H
      INT     15H

      POP     DX
      POP     CX
      POP     AX
    end
 END; { FINE PROCEDURE Delay1 ***********************************************}

{Ŀ}
  PROCEDURE   Delay2 (ritardo:longint);                                    {}
{AUTORE     :Giorgio OBER                                                  }
{VERSIONE   :febbraio 2000                                                 }
{DESCRIZIONE:Questa procedura serve per creare un RITARDO programmabile, in}
{            funzione del valore specificato dal parametro "ritardo".      }
{            Il ritardo prodotto   completamente svincolato dalla velocit}
{            del processore; i tempi del ritardo a multipli del tempo MINI-}
{            MO di 1 millisecondo. La procedura  simile alla "Delay" della}
{            libreria Crt, ma rispetto ad essa,  assolutamente attendibile}
{                                                                          }
{            Per curiosit il valore massimo  per  il parametro "ritardo" }
{            pari 4191888 ms, pari a 4192 s, cio  poco  meno di 69 minuti,}
{            circa 1 ora e 9 minuti!!                                      }
{}
  BEGIN
    Delay1 (ritardo*1024);
 END; { FINE PROCEDURE Delay2 ***********************************************}

{Ŀ}
 PROCEDURE INstring (VAR lunghezza:integer; VAR stringa:Array of char;
                             max,rig,col,testo,sfondo,tipo,giust:integer);{}
{DESCRIZIONE: La PROCEDURA rimane in attesa della pressione di qualunque
{             tasto, fino ad un massimo di "max"; il corrispondente codice
{             ASCII anche ESTESO, viene inserito in una stringa, definita
{             dal programma che chiama questa procedura con dimensione mas-
{             sima di 78 caratteri;
{             I paramtri "rig","col" specificano la posizione in cui si
{             desidera mettere la stringa ASCII in acquisizione, con colori
{             "testo","sfondo"; se il parametro "tipo"=0 l'acquisizione viene
{             organizzata su una singola riga colorata; se "tipo"=1) viene
{             invece introdotta in una cornice esterna alla linea dei carat-
{             teri ammessi
{  Ŀ Nel caso di "tipo"=1, dato che si desidera garantire la stam-}
{           pa dei caratteri uno spazio dopo il bordo  della  CORNICE  di}
{    NB.:   acquisizione, il valore MINIMO per il parametro "colonna" de-}
{           ve essere 4 e il valore MASSIMO del parametro "max" deve  es-}
{           sere 74; analogamente, nel caso  di "tipo"=0 (gestione  SENZA}
{           cornice), volendo garantire ancora uno spazio prima e  dopo i}
{           caratteri in acquisizione, il valore MINIMO  per il parametro}
{           "colonna" deve essere 2 e il valore MASSIMO di "max" deve es-}
{   sere 78. In caso contrario la procedura funziona male.       }
{                                                                          }
{             La procedura RESTITUISCE la variabile "lunghezza" di tipo
{             Integer, con il numero di caratteri effettivamente acquisiti,
{             rispetto a quelli che era possibile inserire (indicati da "max").
{                                                                          }
{             La procedura che chiama questa deve definire  la variabile di
{             tipo integer da passare come primo parametro alla INstrig (per
{             esempio "lung"; e le variabili seguenti (usate da INstrig);
{                 stringa:string[78] o array [1..78] of char;
{                 tasto:char
{}
 VAR        i:integer;
        tasto:char;
 BEGIN
   {Ŀ}
   {Fase di Predisposizione del piano d'acquisizione                      }
   {}
   RipCur;
   textcolor(testo); textbackground(sfondo);
   IF tipo<>0 THEN                                     {Ŀ}
    {Cornice1 (rig  ,col  ,lar  ,alt, txt , sfo  ,tipo){Predispone CORNICE}
     Cornice1 (rig-1,col-3,max+6, 3 ,testo,sfondo,  2,1) {ESTERNA  al  campo}
   ELSE                                                {}
    FOR i:=1 TO max+2 DO             {Ŀ}
    begin                            {                                    }
      gotoxy(col-2+i,rig);           { Predispone il campo d'acquisizione }
      write (' ');                   {      SENZA la CORNICE ESTERNA      }
    end;                             {}
   {Ŀ}
   {Fase di Acquisizione                                                  }
   {}
   gotoxy(col,rig);
   i:=0;
   REPEAT
     IF i<max THEN
       RipCur
     ELSE
       ViaCur;
     REPEAT UNTIL keypressed;        {Ŀ}
     tasto:=readkey;                 { Assunzione di Caratteri da Tastiera}
                                     {}
     IF (tasto>=' ') AND (i<max) THEN
     begin                           {Ŀ}
         i:=i+1;                     {                                    }
         stringa[i]:=tasto;          {  Gestione dei Caratteri Validi     }
         write(tasto);               {                                    }
     end                             {}
     ELSE IF tasto=char(8) THEN      {Ŀ}
      IF i>=1 THEN                   {                                    }
      begin                          {  Gestione per tasto = BackSpace    }
           i:=i-1;                   {                                    }
           write(tasto,' ',tasto);   {                                    }
           RipCur                    {                                    }
      end                            {}
      ELSE                           {Ŀ}
      begin                          {                                    }
           sound(100);               {In ogni altro caso segnala errore !!}
           delay2(300);              {                                    }
           nosound;                  {                                    }
      end                            {}
     ELSE IF tasto<>char(13) THEN    {Ŀ}
     begin                           {                                    }
           sound(100);               {In ogni altro caso segnala errore !!}
           delay2(300);              {                                    }
           nosound;                  {                                    }
     end;                            {}
   UNTIL tasto=char(13);
                                     {Ŀ}
   lunghezza:=i;                     {Lascia l'informazione in uscita     }
                                     {}
   IF (giust=1) AND (i<>max) THEN
   begin
      gotoxy(col,rig); FOR i :=1 TO max-lunghezza DO write (' ');
      FOR i :=1 TO lunghezza DO write (stringa[i]);
   end;
 END; { FINE PROCEDURA INstring ********************************************}

{Ŀ}
  PROCEDURE INnumer (VAR numero:longint; VAR lunghezza:integer;                  {}
                                         VAR stringa: Array of char;
                   max,rig,col,testo,sfondo,tipo,giust:integer);           {}
{DESCRIZIONE: La PROCEDURA rimane in attesa della pressione di tasti esclu-
{             sivamente Numerici, fino ad un massimo di "max"; i corrispon-
{             denti codici ASCII, vengono inserito in una stringa, definita
{             dal programma che chiama questa procedura con dimensione mas-
{             sima di 78 caratteri;
{             I paramtri "rig","col" specificano la posizione in cui si
{             desidera mettere la stringa ASCII in acquisizione, con colori
{             "testo","sfondo"; se il parametro "tipo"=0 l'acquisizione viene
{             organizzata su una singola riga colorata; se "tipo"=1) viene
{             invece introdotta in una cornice esterna alla linea dei carat-
{             teri ammessi
{  Ŀ Nel caso di "tipo"=1, dato che si desidera garantire la stam-}
{           pa dei caratteri uno spazio dopo il bordo  della  CORNICE  di}
{    NB.:   acquisizione, il valore MINIMO per il parametro "colonna" de-}
{           ve essere 4 e il valore MASSIMO del parametro "max" deve  es-}
{           sere 74; analogamente, nel caso  di "tipo"=0 (gestione  SENZA}
{           cornice), volendo garantire ancora uno spazio prima e  dopo i}
{           caratteri in acquisizione, il valore MINIMO  per il parametro}
{           "colonna" deve essere 2 e il valore MASSIMO di "max" deve es-}
{   sere 78. In caso contrario la procedura funziona male.       }
{                                                                          }
{             La procedura RESTITUISCE due informazioni: una  variabile  di}
{             tipo LongINT con il numero intero corrispondente alla STRINGA}
{             ASCII NUMERICA acquisita; e la variabile "lunghezza" di tipo
{             Integer con il numero di caratteri effettivamente acquisiti,
{             rispetto a quelli che era possibile inserire (indicati da "max")
{
{             La procedura che chiama questa deve definire  la variabile di
{             tipo integer da passare come primo parametro alla INstrig (per
{             esempio "lung") e la variabile di tipo longint da passare come
{             secondo parametro alla INstrig (per esempio "num"); inoltre
{             deve definire le variabili seguenti (usate da INstrig):
{                 stringa:string[78] o array [1..78] of char;
{                 tasto:char
{}
 VAR n,l,i,j,r,err:integer;
            ex,tot:longint;
             tasto:char;
 BEGIN
   {Ŀ}
   {Fase di Predisposizione del piano d'acquisizione                      }
   {}
   RipCur;
   textcolor(testo); textbackground(sfondo);
   IF tipo<>0 THEN                                     {Ŀ}
    {Cornice1 (rig  ,col  ,lar  ,alt, txt , sfo  ,tipo){Predispone CORNICE}
     Cornice1 (rig-1,col-3,max+6, 3 ,testo,sfondo,  2,1) {ESTERNA  al  campo}
   ELSE                                                {}
    FOR i:=1 TO max+2 DO             {Ŀ}
    begin                            {                                    }
      gotoxy(col-2+i,rig);           { Predispone il campo d'acquisizione }
      write (' ');                   {      SENZA la CORNICE ESTERNA      }
    end;                             {}
   gotoxy(col,rig);
   {Ŀ}
   {Fase di Acquisizione                                                  }
   {}
   i:=0;
   REPEAT
     IF i<max THEN
       RipCur
     ELSE
       ViaCur;
     REPEAT UNTIL keypressed;        {Ŀ}
     tasto:=readkey;                 { Assunzione di Caratteri da Tastiera}
                                     {}
     IF (tasto>='0') AND (tasto<='9') AND (i<max) THEN
       begin                         {Ŀ}
         i:=i+1;                     {                                    }
         stringa[i]:=tasto;          {  Gestione dei Caratteri Validi     }
         write(tasto);               {                                    }
       end                           {}
       ELSE IF tasto=char(8) THEN    {Ŀ}
        IF i>=1 THEN                 {                                    }
         begin                       {  Gestione per tasto = BackSpace    }
           i:=i-1;                   {                                    }
           write(tasto,' ',tasto);   {                                    }
           RipCur                    {                                    }
         end                         {}
        ELSE                         {Ŀ}
         begin                       {                                    }
           sound(100);               {In ogni altro caso segnala errore !!}
           delay2(300);              {                                    }
           nosound;                  {                                    }
         end                         {}
       ELSE IF tasto<>char(13) THEN  {Ŀ}
         begin                       {                                    }
           sound(100);               {In ogni altro caso segnala errore !!}
           delay2(300);              {                                    }
           nosound;                  {                                    }
         end;                        {}
   UNTIL tasto=char(13);
   {Ŀ}
   {Fase di Conversione                                                   }
   {}
   tot:=0;
   FOR n:=1 to i do
    begin
     ex:=1;                          {Ŀ}
     FOR j:=1 TO i-n DO              {Calcola il Moltiplicatore in Base 10}
       ex:=ex*10;                    {}
     CASE stringa[n]  OF             {Ŀ}
      '0'..'9':val(stringa[n],r,err);{Trasforma ciascun carattere in Numer}
     end;                            {}
                                     {Ŀ}
     tot:=tot+(r*ex);                {Aggiorna il Totale Progressivo      }
    end;                             {}
   numero:=tot;                      {Ŀ}
   lunghezza:=i;                          {Lascia le due informazioni in uscita}
                                     {}
   IF (giust=1) AND (i<>max) THEN
   begin
      gotoxy(col,rig); FOR i :=1 TO max-lunghezza DO write (' ');
      FOR i :=1 TO lunghezza DO write (stringa[i]);
   end;
 END; { FINE PROCEDURA INnumer  ********************************************}

{Ŀ}
  PROCEDURE INexad (VAR numero:longint;  VAR lunghezza:integer;            {}
                                         VAR stringa: Array of char;
                   max,rig,col,testo,sfondo,tipo,giust:integer);           {}
{DESCRIZIONE: La PROCEDURA rimane in attesa della pressione di tasti esclu-
{             sivamente Numerici e/o Letterali da "A" a "F", fino ad un
{             massimo di "max"; i corrispondenti codici ASCII, vengono
{             inseriti in una stringa, definita dal programma che chiama
{             questa procedura con dimensione mas- sima di 78 caratteri;
{             I paramtri "rig","col" specificano la posizione in cui si
{             desidera mettere la stringa ASCII in acquisizione, con colori
{             "testo","sfondo"; se il parametro "tipo"=0 l'acquisizione viene
{             organizzata su una singola riga colorata; se "tipo"=1) viene
{             invece introdotta in una cornice esterna alla linea dei carat-
{             teri ammessi
{  Ŀ Nel caso di "tipo"=1, dato che si desidera garantire la stam-}
{           pa dei caratteri uno spazio dopo il bordo  della  CORNICE  di}
{    NB.:   acquisizione, il valore MINIMO per il parametro "colonna" de-}
{           ve essere 4 e il valore MASSIMO del parametro "max" deve  es-}
{           sere 74; analogamente, nel caso  di "tipo"=0 (gestione  SENZA}
{           cornice), volendo garantire ancora uno spazio prima e  dopo i}
{           caratteri in acquisizione, il valore MINIMO  per il parametro}
{           "colonna" deve essere 2 e il valore MASSIMO di "max" deve es-}
{   sere 78. In caso contrario la procedura funziona male.       }
{                                                                          }
{             La procedura RESTITUISCE due informazioni: una  variabile  di}
{             tipo LongINT con il numero decimale intero corrispondente
{             alla STRINGA ASCII esadecimale acquisita; e la variabile
{             "lunghezza" di tipo Integer con il numero di caratteri effet-
{             tivamente acquisiti, rispetto a quelli che era possibile
{             inserire (indicati da "max").
{
{             La procedura che chiama questa deve definire  la variabile di
{             tipo integer da passare come primo parametro alla INstrig (per
{             esempio "lung") e la variabile di tipo longint da passare come
{             secondo parametro alla INstrig (per esempio "num"); inoltre
{             deve definire le variabili seguenti (usate da INstrig):
{                 stringa:string[78] o array [1..78] of char;
{                 tasto:char
{}
 VAR n,l,i,j,r,err:integer;
            ex,tot:longint;
             tasto:char;
 BEGIN
   {Ŀ}
   {Fase di Predisposizione del piano d'acquisizione                      }
   {}
   RipCur;
   textcolor(testo); textbackground(sfondo);
   IF tipo<>0 THEN                                     {Ŀ}
    {Cornice1 (rig  ,col  ,lar  ,alt, txt , sfo  ,tipo){Predispone CORNICE}
     Cornice1 (rig-1,col-3,max+6, 3 ,testo,sfondo,  2,1) {ESTERNA  al  campo}
   ELSE                                                {}
    FOR i:=1 TO max+2 DO             {Ŀ}
    begin                            {                                    }
      gotoxy(col-2+i,rig);           { Predispone il campo d'acquisizione }
      write (' ');                   {      SENZA la CORNICE ESTERNA      }
    end;                             {}
   gotoxy(col,rig);
   {Ŀ}
   {Fase di Acquisizione                                                  }
   {}
   i:=0;
   REPEAT
     IF i<max THEN
       RipCur
     ELSE
       ViaCur;
     REPEAT UNTIL keypressed;        {Ŀ}
     tasto:=readkey;                 { Assunzione di Caratteri da Tastiera}
                                     {}
     IF ((tasto>='0') AND (tasto<='9') OR
         (UpCase(tasto)>='A') AND (UpCase(tasto)<='F')) AND (i<max) THEN
       begin                         {Ŀ}
         i:=i+1;                     {                                    }
         stringa[i]:=UpCase(tasto);  {  Gestione dei Caratteri Validi     }
         write(UpCase(tasto));       {                                    }
       end                           {}
       ELSE IF tasto=char(8) THEN    {Ŀ}
        IF i>=1 THEN                 {                                    }
         begin                       {  Gestione per tasto = BackSpace    }
           i:=i-1;                   {                                    }
           write(tasto,' ',tasto);   {                                    }
           RipCur                    {                                    }
         end                         {}
        ELSE                         {Ŀ}
         begin                       {                                    }
           sound(100);               {In ogni altro caso segnala errore !!}
           delay2(300);              {                                    }
           nosound;                  {                                    }
         end                         {}
       ELSE IF tasto<>char(13) THEN  {Ŀ}
         begin                       {                                    }
           sound(100);               {In ogni altro caso segnala errore !!}
           delay2(300);              {                                    }
           nosound;                  {                                    }
         end;                        {}
   UNTIL tasto=char(13);
   {Ŀ}
   {Fase di Conversione                                                   }
   {}
   tot:=0;
   FOR n:=1 to i do
    begin
     ex:=1;                          {Ŀ}
     FOR j:=1 TO i-n DO              {Calcola il Moltiplicatore in Base 16}
       ex:=ex*16;                    {}
     CASE stringa[n] OF              {Ŀ}
      '0'..'9':val(stringa[n],r,err);{                                    }
      'A'     :r:=10;                {                                    }
      'B'     :r:=11;                {    Trasforma ogni carattere nel    }
      'C'     :r:=12;                {                                    }
      'D'     :r:=13;                {      numero corrispondente         }
      'E'     :r:=14;                {                                    }
      'F'     :r:=15;                {                                    }
     end;                            {}
                                     {Ŀ}
     tot:=tot+(r*ex);                {Aggiorna il Totale Progressivo      }
    end;                             {}
   numero:=tot;                      {Ŀ}
   lunghezza:=i;                     {Lascia le due informazioni in uscita}
                                     {}
   IF (giust=1) AND (i<>max) THEN
   begin
      gotoxy(col,rig); FOR i :=1 TO max-lunghezza DO write (' ');
      FOR i :=1 TO lunghezza DO write (stringa[i]);
   end;
 END; { FINE PROCEDURA INexad   ********************************************}

{Ŀ}
  PROCEDURE NewCorn (rig,col,lar,alt,txt,sfo,ombP,ombS,tipo:byte          ;{}
                                                     numPAG:byte)         ;{}
{DESCRIZIONE: La procedura stampa una cornice a partire  dall'angolo speci-}
{             ficato da "rig,col" (range [1,1][22,74] in MODO standard 3);}
{             le dimensioni "lar"(lunghezza ) e  "alt"(altezza)  sono  com-}
{             prensive della cornice(esclusa ombra)   cio  per  esempio se}
{             rig,col=1,1, al massimo [76+4=78] per [22+2=24] caratteri;  i}
{             colori sono "txt" per la cornice e "sfo" per lo sfondo; i pa-}
{             rametri "ombP" e "ombS" specificano il colore di primo  piano}
{             e dello sfondo da imporre ai caratteri che occupano (sotto la}
{             cornice) le posizioni adatte a creare l'effetto ombra (da no-}
{             tare che, per un effetto ombra classico,  bianco  su  nero, i}
{             valori ideali sono "ombP"=7 e "ombS"=0); il  parametro "tipo"}
{             specifica  l'aspetto  della  cornice (tipo=1="Ŀ", tipo=2=}
{             ="ͻ",  tipo=3="*****",  tipo=4="",   tipo=5="",}
{             tipo=6=""). Anche se sembra inutile sottolinearlo le di- }
{             mensioni della cornice potranno andare dalla ~minima~ lar,alt}
{             =4,2 (per altro inutile essendo costituita dalla sola  corni-}
{             ce) alla ~massima~  lar,alt=78,24, tenuto conto della presen-}
{             za dell'ombra.                                               }
{             La procedura  scritta completamente in Assembler e ottimizza}
{             il lavoro della "Cornice3", SALVANDO I  CARATTERI SOTTOSTANTI}
{             nella pagina video identificata dal parametro "numPAG", 0=pa-}
{             gina corrente, 17=pagine alternative;  inoltre  controlla il}
{             Mouse disabilitandone la visualizzazione nella fase di salva-}
{             taggio e di stampa e riabilitandola al termine.              }
{             Infine gestisce i check-point [] e [] per il  Mouse,  utili}
{             per la gestione della cornice (chiusura, espansione, ecc.)   }
{}
  BEGIN
    asm
      PUSH    ES
      PUSH    SI
      PUSH    DI
      PUSH    CX
      PUSH    BX
      PUSH    DX

      JMP     @@0
@TAB: DB     'ڿĳ'              {Ŀ}
      DB     'ɻȼͺ'              {                                       }
      DB     '******'              {Tabella della tipologia della cornice  }
      DB     ''              {                                       }
      DB     ''              {                                       }
      DB     ''              {}
@@0:  LEA     SI,@TAB              {Ŀ}
      MOV     AL,tipo              {                                       }
      DEC     AL                   {Prepara il puntatore alla tabella      }
      MOV     BL,6                 {della tipologia della cornice          }
      MUL     BL                   {                                       }
      ADD     SI,AX                {}
      MOV     AX,0B800H            {Ŀ}
      MOV     ES,AX                {Fissa l'area Ram del Video             }
                                   {}
                                   {[ViaMouse]Ŀ}
                                   {Disabilita la visualizzazione del cur- }
      MOV     AX,0002H             {sore del MOUSE; prima di salvare  aree }
      INT     33H                  {in RamVideo  sempre operazione utile  }
                                   {}
      {***************************** indirizzo:=(col-1)*2+(rig-1)*160; ******}
      MOV     AL,col               {Ŀ}
      MOV     AH,00H               {                                       }
      MOV     DI,AX                { DI=(col-1)*2                          }
      DEC     DI                   {                                       }
      ADD     DI,DI                {                                       }
                                   { --------------------------------------}
      MOV     BL,rig               {                                       }
      DEC     BL                   { BX =(rig-1)*160                       }
      MOV     AX,160               {                                       }
      MUL     BL                   {                                       }
                                   { --------------------------------------}
      ADD     DI,AX                {DI=indirizzo:=(col-1)*2+(rig-1)*160;   }
      PUSH    DI                   {}
      {***************** salva "alto+1" righe coperte dalla cornice *********}
      PUSH    DI                   {Ŀ}
      PUSH    SI                   {                                       }
      MOV     CL,numPAG            {                                       }
      MOV     CH,00H               {Calcola l'indirizzo della Pagina in cui}
      MOV     AX,1000H             {salvare                                }
      MUL     CX                   {                                       }
      MOV     SI,AX                {                                       }
      ADD     SI,DI                {}
      MOV     CL,alt               {Ŀ}
      INC     CL                   {salva  alt+1 righe sotto la cornice    }
      MOV     CH,00H               {per tener conto dell'ombra             }
@@8:  PUSH    CX                   {}
      MOV     CH,00H               {Ŀ}
      MOV     CL,lar               {salva lar+2 colonne sotto la cornice   }
      ADD     CL,2                 {per tener conto dell'ombra             }
      PUSH    CX                   {                                       }
@@9:  MOV     AX,ES:[DI]           {                                       }
      MOV     ES:[SI],AX           {                                       }
      ADD     DI,2                 {                                       }
      ADD     SI,2                 {                                       }
      LOOP    @@9                  {}
      MOV     BX,80                {Ŀ}
      POP     CX                   {calcola i bytes da saltare per         }
      SUB     BX,CX                {riportarsi a capo                      }
      ADD     BX,BX                {                                       }
      ADD     SI,BX                {                                       }
      ADD     DI,BX                {                                       }
      POP     CX                   {                                       }
      LOOP    @@8                  {                                       }
      POP     SI                   {                                       }
      POP     DI                   {}
      {*****************  preparala stampa della cornice ********************}
      MOV     BH,sfo               {Ŀ}
      SHL     BH,1                 {                                       }
      SHL     BH,1                 {                                       }
      SHL     BH,1                 {Ricostruisce in AH                     }
      SHL     BH,1                 {                 l'attributo di colore }
      MOV     BL,txt               {                                       }
      OR      BH,BL                {                                       }
      MOV     AH,BH                {}
      {****************  stampa la prima  riga in alto **********************}
                                   {Ŀ}
      MOV     AL,CS:[SI]           {Stampa il primo carattere del tratto   }
      MOV     ES:[DI],AX           {superiore della cornice,               }
      ADD     DI,2                 {    '' o '' o '*' o '' o '' o ''  }
                                   {}
      MOV     BH,tipo              {Ŀ}
      MOV     AL,''               {Stampa largo-2 volte il secondo carat- }
      CMP     BH,5                 {tere del tratto superiore della cornice}
      JZ      @00                  {                                       }
      MOV     AL,CS:[SI+4]         {   '' o '' o '*' o '' o '' o ''   }
@00:  MOV     CH,00H               {                                       }
      MOV     CL,lar               {                                       }
      PUSH    CX                   {                                       }
      CMP     CL,2                 {                                       }
      JBE     @01                  {                                       }
      SUB     CL,2                 {se lar<=2  stampa  solo "ڿ"   e  non  }
@@1:  MOV     ES:[DI],AX           {esegue il loop                         }
      ADD     DI,2                 {                                       }
      LOOP    @@1                  {}
                                   {Ŀ}
@01:  MOV     AL,CS:[SI+1]         {Stampa l'ultimo carattere del tratto   }
      MOV     ES:[DI],AX           {superiore della cornice,               }
      ADD     DI,2                 {   '' o '' o '*' o '' o '' o ''   }
                                   {}
      MOV     BX,80                {Ŀ}
      POP     CX                   {calcola i bytes da saltare per         }
      SUB     BX,CX                {riportarsi a capo                      }
      ADD     BX,BX                {                                       }
      ADD     DI,BX                {}
      {****************  stampa "alto-2" righe in mezzo *********************}
      MOV     CL,alt               {Ŀ}
      SUB     CL,2                 {                                       }
      MOV     CH,00H               {prevede CX=alto-2 giri                 }
@@2:  PUSH    CX                   {}
                                   {Ŀ}
      MOV     AL,CS:[SI+5]         {Stampa il primo carattere del tratto   }
      MOV     ES:[DI],AX           {mediano  della  cornice,               }
      ADD     DI,2                 {     '' o '' o '*' o '' o '' o '' }
                                   {}
      MOV     AL,' '               {Ŀ}
      MOV     CH,00H               {                                       }
      MOV     CL,lar               {Stampa largo-2 volte lo spazio interno }
      PUSH    CX                   {al tratto mediano della cornice        }
      CMP     CL,2                 {                                       }
      JBE     @02                  {                                       }
      SUB     CL,2                 {                                       }
@@3:  MOV     ES:[DI],AX           {se lar<=2  stampa  solo ""   e  non  }
      ADD     DI,2                 {esegue il loop                         }
      LOOP    @@3                  {}
                                   {Ŀ}
@02:  MOV     AL,CS:[SI+5]         {Stampa l'ultimo carattere del tratto   }
      MOV     ES:[DI],AX           {mediano   della cornice,               }
      ADD     DI,2                 {     '' o '' o '*' o '' o '' o '' }
                                   {}
      MOV     BH,ombS              {Ŀ}
      SHL     BH,1                 {crea l'ombra di due caratteri a destra }
      SHL     BH,1                 {                                       }
      SHL     BH,1                 {Ricostruisce in AH                     }
      SHL     BH,1                 {                 l'attributo di colore }
      MOV     BL,ombP              {                                       }
      OR      BH,BL                {                                       }
      INC     DI                   {                                       }
     {MOV     BL,lar               {                                       }
     {MOV     DL,80                {                                       }
     {MOV     DH,col               {                                       }
     {SUB     DL,DH                {                                       }
     {CMP     BL,DL                {IF lar<80 THEN                         }
     {JE      @04                  {Attrchr(rig+alt-1,lar+col,ombP,ombS);  }
      MOV     ES:[DI],BH           {                                       }
      ADD     DI,2                 {                                       }
     {DEC     DL                   {                                       }
     {CMP     BL,DL                {IF lar<79 THEN                         }
     {JE      @05                  {Attrchr(rig+alt-1,lar+col+1,ombP,ombS);}
      MOV     ES:[DI],BH           {                                       }
      JMP     @05                  {                                       }
@04:  ADD     DI,2                 {                                       }
@05:  INC     DI                   {}
      MOV     BX,78                {Ŀ}
      POP     CX                   {calcola i bytes da saltare per         }
      SUB     BX,CX                {riportarsi a capo                      }
      ADD     BX,BX                {                                       }
      ADD     DI,BX                {}
      POP     CX
      LOOP    @@2
      {****************  stampa l'ultima  riga in basso *********************}
                                   {Ŀ}
      MOV     AL,CS:[SI+2]         {Stampa il primo carattere del tratto   }
      MOV     ES:[DI],AX           {inferiore della cornice,               }
      ADD     DI,2                 {    '' o '' o '*' o '' o '' o ''  }
                                   {}
      MOV     BH,tipo              {Ŀ}
      MOV     AL,''               {Stampa largo-2 volte il secondo carat- }
      CMP     BH,5                 {tere del tratto inferiore della cornice}
      JZ      @20                  {                                       }
      MOV     AL,CS:[SI+4]         {   '' o '' o '*' o '' o '' o ''   }
@20:  MOV     CH,00H               {                                       }
      MOV     CL,lar               {                                       }
      PUSH    CX                   {                                       }
      CMP     CL,2                 {                                       }
      JBE     @22                  {                                       }
      SUB     CL,2                 {se lar<=2  stampa  solo ""   e  non  }
@@4:  MOV     ES:[DI],AX           {esegue il loop                         }
      ADD     DI,2                 {                                       }
      LOOP    @@4                  {}
                                   {Ŀ}
@22:  MOV     AL,CS:[SI+3]         {Stampa l'ultimo carattere del tratto   }
      MOV     ES:[DI],AX           {inferiore della cornice,               }
      ADD     DI,2                 {   '' o '' o '*' o '' o '' o ''   }
                                   {}
      {**************** gestisce l'ombra sotto la cornice *******************}
      MOV     BH,ombS              {Ŀ}
      SHL     BH,1                 {crea l'ombra di due caratteri a destra }
      SHL     BH,1                 {                                       }
      SHL     BH,1                 {Ricostruisce in AH                     }
      SHL     BH,1                 {                 l'attributo di colore }
      MOV     BL,ombP              {                                       }
      OR      BH,BL                {                                       }
      INC     DI                   {                                       }
      MOV     BL,lar               {                                       }
      CMP     BL,80                {IF lar<80 THEN                         }
      JE      @06                  {Attrchr(rig+alt-1,lar+col,ombP,ombS);  }
      MOV     ES:[DI],BH           {                                       }
      ADD     DI,2                 {                                       }
      CMP     BL,79                {IF lar<79 THEN                         }
      JE      @07                  {Attrchr(rig+alt-1,lar+col+1,ombP,ombS);}
      MOV     ES:[DI],BH           {                                       }
      JMP     @07                  {                                       }
@06:  ADD     DI,2                 {                                       }
@07:  INC     DI                   {}
      MOV     BX,78                {Ŀ}
      POP     CX                   {calcola i bytes da saltare per         }
      SUB     BX,CX                {riportarsi a capo                      }
      ADD     BX,BX                {                                       }
      ADD     DI,BX                {}
      MOV     BH,ombS              {Ŀ}
      SHL     BH,1                 {crea l'ombra sottostante               }
      SHL     BH,1                 {                                       }
      SHL     BH,1                 {Ricostruisce in AH                     }
      SHL     BH,1                 {                 l'attributo di colore }
      MOV     BL,ombP              {                                       }
      OR      BH,BL                {                                       }
      ADD     DI,3                 {                                       }
      MOV     CH,00H               {                                       }
      MOV     CL,lar               {                                       }
      CMP     CL,80                {IF lar=80 THEN  CX=larg - 2            }
      JE      @08                  {                                       }
      CMP     CL,79                {IF lar=79 THEN  CX=larg - 1            }
      JE      @09                  {                                       }
      JMP     @10                  {                                       }
@08:  DEC     CX                   {                                       }
@09:  DEC     CX                   {                                       }
@10:  INC     CX                   {                                       }
@11:  MOV     ES:[DI],BH           {                                       }
      ADD     DI,2                 {                                       }
      LOOP    @11                  {}
      {****************  gestisce i simboli per il mouse ********************}
                                   {Ŀ}
      POP     DI                   {DI=indirizzo:=(col-1)*2+(rig-1)*160;   }
                                   {}
                                   {Ŀ}
      ADD     DI,4                 {                                       }
      MOV     AL,'['               {stampa il check-point [] per il Mouse }
      MOV     ES:[DI],AX           {                                       }
      ADD     DI,2                 {                                       }
      MOV     AL,''               {                                       }
      MOV     ES:[DI],AX           {                                       }
      ADD     DI,2                 {                                       }
      MOV     AL,']'               {                                       }
      MOV     ES:[DI],AX           {                                       }
                                   {---------------------------------------}
      MOV     DH,00H               {                                       }
      MOV     DL,lar               {                                       }
      ADD     DL,DL                {                                       }
      SUB     DL,18                {                                       }
      ADD     DI,DX                {                                       }
      MOV     AL,'['               {stampa il check-point [] per il Mouse }
      MOV     ES:[DI],AX           {                                       }
      ADD     DI,2                 {                                       }
      MOV     AL,''               {                                       }
      MOV     ES:[DI],AX           {                                       }
      ADD     DI,2                 {                                       }
      MOV     AL,']'               {                                       }
      MOV     ES:[DI],AX           {                                       }
                                   {}
                                   {[VediMouse]Ŀ}
                                   {Riabilita la visualizzazione del curso-}
      MOV     AX,0001H             {re del MOUSE; prima di recuperare aree }
      INT     33H                  {da RamVideo  sempre operazione utile  }
                                   {}
      POP     DX
      POP     BX
      POP     CX
      POP     DI
      POP     SI
      POP     ES
    end;
  END; { FINE PROCEDURA NewCorn  ********************************************}

{Ŀ}
  PROCEDURE    NewRecup (rig,col,lar,alt,numPAG:byte)                     ;{}
{DESCRIZIONE: La procedura scritta in linguaggio macchina per 8086 consente}
{             di recuperare il contenuto di una finestra(caratteri e attri-}
{             buti di colore)  attualmente posta nella pagina video identi-}
{             ficata dal parametro "numPAG" (0= pagina corrente,17= pagine}
{             alternative), con angolo in alto a sinistra "rig,col"  e  di-}
{             mensioni "lar,alt" (larghezza, altezza); tutte le  coppie  di}
{             bytes vengono copiate nella pagina video corrente; da  notare}
{             che l'angolo in alto a sinistra ha  coordinate [1,1] e quello}
{             in basso a destra [25,80] (MODO TESTO standard n3).         }
{             La procedura recupera in realt una riga e due colonne in pi}
{             per assicurare il recupero anche dell'area coperta dall'ombra}
{             prevista dalla procedura "NewCorn" alla quale questa si rife-}
{             risce; inoltre  controlla il Mouse disabilitandone la  visua-}
{             lizzazione nella fase di recupero e riabilitandola al termine}
{}
  BEGIN
    asm
      PUSH    ES
      PUSH    SI
      PUSH    DI
      PUSH    CX
      PUSH    BX
      PUSH    DX
                                   {[ViaMouse]Ŀ}
                                   {Disabilita la visualizzazione del cur- }
      MOV     AX,0002H             {sore del MOUSE; prima di salvare  aree }
      INT     33H                  {in RamVideo  sempre operazione utile  }
                                   {}
      MOV     AX,0B800H            {Ŀ}
      MOV     ES,AX                {Fissa l'area Ram del Video             }
                                   {}
      {***************************** indirizzo:=(col-1)*2+(rig-1)*160; ******}
      MOV     AL,col               {Ŀ}
      MOV     AH,00H               {                                       }
      MOV     DI,AX                { DI=(col-1)*2                          }
      DEC     DI                   {                                       }
      ADD     DI,DI                {                                       }
                                   { --------------------------------------}
      MOV     BL,rig               {                                       }
      DEC     BL                   { BX =(rig-1)*160                       }
      MOV     AX,160               {                                       }
      MUL     BL                   {                                       }
                                   { --------------------------------------}
      ADD     DI,AX                {DI=indirizzo:=(col-1)*2+(rig-1)*160;   }
                                   {}
      {************** recupera "alto+1" righe coperte dalla cornice *********}
      MOV     CL,numPAG            {Ŀ}
      MOV     CH,00H               {                                       }
      MOV     AX,1000H             {                                       }
      MUL     CX                   {                                       }
      MOV     SI,AX                {                                       }
      ADD     SI,DI                {}
      MOV     CL,alt               {Ŀ}
      INC     CL                   {prevede il recupero di alt+1 righe     }
      MOV     CH,00H               {per tener conto dell'ombra             }
@@8:  PUSH    CX                   {}
      MOV     CH,00H               {Ŀ}
      MOV     CL,lar               {prevede il recupero di lar+2 colonne   }
      ADD     CL,2                 {per tener conto dell'ombra             }
      PUSH    CX                   {                                       }
@@9:  MOV     AX,ES:[SI]           {                                       }
      MOV     ES:[DI],AX           {                                       }
      ADD     DI,2                 {                                       }
      ADD     SI,2                 {                                       }
      LOOP    @@9                  {}
      MOV     BX,80                {Ŀ}
      POP     CX                   {calcola i bytes da saltare per         }
      SUB     BX,CX                {riportarsi a capo                      }
      ADD     BX,BX                {                                       }
      ADD     SI,BX                {                                       }
      ADD     DI,BX                {                                       }
      POP     CX                   {                                       }
      LOOP    @@8                  {}
                                   {[VediMouse]Ŀ}
                                   {Riabilita la visualizzazione del curso-}
      MOV     AX,0001H             {re del MOUSE; prima di recuperare aree }
      INT     33H                  {da RamVideo  sempre operazione utile  }
                                   {}
      POP     DX
      POP     BX
      POP     CX
      POP     DI
      POP     SI
      POP     ES
      end;

  END; { FINE PROCEDURA NewRecup ********************************************}

{Ŀ}
 FUNCTION     pulMou: word                                                ;{}
{DESCRIZIONE:Procedura MOUSE che lascia in "pulMou" lo  stato  dei pulsanti}
{            del MOUSE; in dettaglio:                                      }
{  "pulMou"= 0 = ****** NESSUN pulsante del MOUSE risulta PREMUTO *********}
{  "pulMou"= 1 = pulsSIN= premuto    pulsDEX=rilasciato pulsCENT=rilasciato}
{  "pulMou"= 2 = pulsSIN=rilasciato  pulsDEX= premuto   pulsCENT=rilasciato}
{  "pulMou"= 3 = pulsSIN= premuto    pulsDEX= premuto   pulsCENT=rilasciato}
{  "pulMou"= 4 = pulsSIN=rilasciato  pulsDEX=rilasciato pulsCENT= premuto  }
{  "pulMou"= 5 = pulsSIN= premuto    pulsDEX=rilasciato pulsCENT= premuto  }
{  "pulMou"= 6 = pulsSIN=rilasciato  pulsDEX= premuto   pulsCENT= premuto  }
{  "pulMou"= 7 = **** TUTTI i pulsanti del MOUSE risultano PREMUTI ********}
{}
 VAR
    depo:word;
 BEGIN
   asm
       PUSH    AX
       PUSH    BX
       MOV     AX,0003H
       INT     33H
       MOV     depo,BX
       POP     BX
       POP     AX
   end;
   pulMou:=depo;
 END; { FINE FUNCTION  pulMou ***********************************************}

{Ŀ}
 FUNCTION     rigMou(pixel:boolean): word                                 ;{}
{DESCRIZIONE:Procedura MOUSE che lascia in "rigMou" la coordinata  Y (riga)}
{            della posizione attuale del cursore  del   MOUSE; se il valore}
{            corrente del parametro "pixel" (boolean)  VERO il  numero la-}
{            sciato  in "rigMou"   in  pixel (range 0*824*8,0192,in modo}
{            TESTO, 03) altrimenti il numero  quello classico (range 125)}
{            dell'ordinata espressa in caratteri.                          }
{}
 VAR
    depo:word;
 BEGIN
 IF pixel THEN
   asm
       PUSH    AX
       PUSH    DX
       MOV     AX,0003H
       INT     33H
       MOV     depo,DX
       POP     DX
       POP     AX
   end
 ELSE
   asm
       PUSH    AX
       PUSH    DX
       MOV     AX,0003H
       INT     33H
       SAR     DX,1
       SAR     DX,1
       SAR     DX,1
       INC     DX
       MOV     depo,DX
       POP     DX
       POP     AX
   end;
   rigMou:=depo;
 END; { FINE FUNCTION  rigMou ***********************************************}


{Ŀ}
 FUNCTION     colMou(pixel:boolean): word                                 ;{}
{DESCRIZIONE:Procedura MOUSE che lascia in "colMou" la coordinata X, colon-}
{            na della posizione attuale del cursore  del  MOUSE; se il  va-}
{            lore corrente del parametro "pixel" (boolean)  VERO il numero}
{            lasciato in "colMou"  in pixel (range 0*879*8, 0632, in mo-}
{            do TESTO, 03) altrimenti il numero  quello classico (range 1}
{            80) dell'ascissa espressa in caratteri.                       }
{}
 VAR
    depo:word;
 BEGIN
 IF pixel THEN
   asm
       PUSH    AX
       PUSH    CX
       MOV     AX,0003H
       INT     33H
       MOV     depo,CX
       POP     CX
       POP     AX
   end
 ELSE
   asm
       PUSH    AX
       PUSH    CX
       MOV     AX,0003H
       INT     33H
       SAR     CX,1
       SAR     CX,1
       SAR     CX,1
       INC     CX
       MOV     depo,CX
       POP     CX
       POP     AX
   end;
   colMou:=depo;
 END; { FINE FUNCTION  colMou ***********************************************}

{Ŀ}
 FUNCTION     DestroMou : boolean                                         ;{}
{DESCRIZIONE:Funzione che risulta VERA se  premuto il pulsante  DESTRO del}
{            MOUSE                                                         }
{}
 BEGIN
    DestroMou:=(pulMou=2) OR (pulMou=3) OR (pulMou=6) OR (pulMou=7);
 END; { FINE FUNCTION  DestroMou  *******************************************}


{Ŀ}
 FUNCTION     SinistMou : boolean                                         ;{}
{DESCRIZIONE:Funzione che risulta VERA se  premuto  il  pulsante  SINISTRO}
{            del MOUSE                                                     }
{}
 BEGIN
    SinistMou:=(pulMou=1) OR (pulMou=3) OR (pulMou=5) OR (pulMou=7);
 END; { FINE FUNCTION  SinistMou  *******************************************}


{Ŀ}
 FUNCTION     CentroMou : boolean                                         ;{}
{DESCRIZIONE:Funzione che risulta VERA se  premuto  il  pulsante  CENTRALE}
{            del MOUSE                                                     }
{}
 BEGIN
    CentroMou:=(pulMou=4) OR (pulMou=5) OR (pulMou=6) OR (pulMou=7);
 END; { FINE FUNCTION  CentroMou  *******************************************}


{Ŀ}
 FUNCTION     StillKey:boolean                                            ;{}
{DESCRIZIONE:La funzione  scritta in linguaggio macchina  per 8086  aspetta}
{            che l'utente "stacchi" il dito dal tasto !!!                  }
{}
 VAR
    depo:word;
 BEGIN
   StillKey:=false;

   asm
       PUSH    AX
       MOV     AH,01H
       INT     16H
       PUSHF            {Z=1=no; NZ=0=si}
       POP     AX
       AND     AX,0040H
       MOV     depo,AX  {depo<>0=no; depo=0=si}
       POP     AX
   end;
   StillKey:=(depo=0)  {Z =1 = depo<>0 =StillKey=false carattere    scaricato}
                       {NZ=0 = depo= 0 =StillKey=true  carattere da scaricare}
 END; { FINE FUNCTION  StillKey *********************************************}

{Ŀ}
 FUNCTION     Mouse:boolean                                               ;{}
{DESCRIZIONE:Controlla la presenza del DRIVER del MOUSE: se esso  disponi-}
{            le restituisce in "Mouse" lo stato del MOUSE (false =installa-}
{            to, true=non installato).                                     }
{}
 VAR
   test:word;
 BEGIN
   Mouse:=true;
   asm
       PUSH    AX
       MOV     AX,0000H
       INT     33H
       MOV     test,AX
       POP     AX
   end;
   IF  test=0 THEN
      Mouse:=false;
 END; { FINE FUNCTION  Mouse ************************************************}

{Ŀ}
 FUNCTION     quantiMou:word                                              ;{}
{DESCRIZIONE:Controlla la presenza del DRIVER del MOUSE: se esso  disponi-}
{            bile ne attiva le funzioni impostando sul dispositivo i  para-}
{            metri di default, tra cui: cursore nascosto, in  modo  testo e}
{            posto al centro dello schermo e  restituisce  in "quantMou" il}
{            numero di pulsanti del MOUSE:                                 }
{            "quantiMou"= 2 =due,  "quantiMou"= 0= valore diverso da 2     }
{}
 VAR
   test,quantiMou:word;
 BEGIN
   asm
       PUSH    AX
       MOV     AX,0000H
       INT     33H
       MOV     test,AX
       MOV     quantiMou,BX
       POP     AX
   end;
 END; { FINE FUNCTION  quantiMou ********************************************}

{Ŀ}
 FUNCTION  DataIN (VAR Anno,Mese,Giorno,NomeGiorn):Word                   ;{}
{DESCRIZIONE: La procedura assume la  DATA corrente nelle variabili citate.}
{}
 {VAR
   Anno,Mese,Giorno,NomeGiorn:word;}
 BEGIN
   asm
       MOV     AH,2AH
       INT     21H
       XOR     AH,AH
       LES     DI,NomeGiorn
       STOSW
       MOV     AL,DL
       LES     DI,Giorno
       STOSW
       MOV     AL,DH
       LES     DI,Mese
       STOSW
       XCHG    AX,CX
       LES     DI,Anno
       STOSW
   end;
 END; { FINE FUNCTION  DataIN ***********************************************}

{Ŀ}
 FUNCTION  OraIN (VAR Ora,Minuti,Secondi,Centesimi):Word                  ;{}
{DESCRIZIONE: La procedura assume l'ORA  corrente nelle variabili citate   }
{}
 {VAR
   Ora,Minuti,Secondi,Centesimi:Word;}
 BEGIN
   asm
       MOV     AH,2CH
       INT     21H
       XOR     AH,AH
       MOV     AL,DL
       LES     DI,Centesimi
       STOSW
       MOV     AL,DH
       LES     DI,Secondi
       STOSW
       MOV     AL,CL
       LES     DI,Minuti
       STOSW
       MOV     AL,CH
       LES     DI,Ora
       STOSW
   end;
 END; { FINE FUNCTION ORAin *************************************************}

{Ŀ}
 FUNCTION     ChkKey (VAR ascii,scans:word):boolean                       ;{}
{AUTORE     :Giorgio OBER                                                  }
{VERSIONE   :febbraio 1995                                                 }
{DESCRIZIONE:La Funzione  vera se  stato premuto almeno un tasto; in que-}
{            sto caso le due variabili "ascii" e "scans" rendono disponibi-}
{            li rispettivamente il codoce ASCII del tasto premuto e il  suo}
{            codice di scansione, lasciando libero il BUFFER della tastiera}
{}
 VAR
   test:byte;
 BEGIN
  ChkKey:=false;
  asm
       PUSH    AX
       PUSH    DI
       MOV     test,0
       MOV     AH,01H        {Se NESSUN tasto  stato premuto: ffZ=1 (Z)    }
       INT     16H
       JZ      @@1
                             {Se  stato premuto un tasto lascia ffZ=0 (NZ),}
       MOV     AH,00H        {AL=codice ASCII e AH=codice di scansione; essi}
       INT     16H           {DEVONO ESSERE ESTRATTI dal buffer con un'altra}
                             {chiamata di INT 16H con parametro 00H         }
       PUSH    AX
       XOR     AH,AH
       LES     DI,ascii
       STOSW
       POP     AX
       MOV     AL,AH
       XOR     AH,AH
       LES     DI,scans
       STOSW
       MOV     test,1
@@1:   POP     DI
       POP     AX
  end;
   IF  test=1 THEN
      ChkKey:=true;
 END; { FINE FUNCTION ChkKey ************************************************}

{Ŀ}
 FUNCTION       ChkClick (rig,col1,col2:word):boolean                     ;{}
{DESCRIZIONE : Rileva la presenza del cursore  nell'area  VIDEO  sulla riga}
{              "rig" e tra le colonne "col1" e "col2" (espresse COMUNQUE in}
{              caratteri) e, solo in questo caso, se viene  premuto  almeno}
{              un pulsante del MOUSE lascia VERA la variabile "ChkClick"   }
{}
 VAR   pixel:boolean;
 BEGIN
   ChkClick:=false;
   pixel:=false;
   IF ((rigMou(pixel)=rig)   AND
       (colMou(pixel)<=col2) AND
       (colMou(pixel)>=col1) AND
       (pulMou<>0))          THEN
     ChkClick:=true;   {se si  nel riquadro  ed  stato premuto un pulsante}
 END; { FINE FUNCTION  ChkClick *********************************************}

{Ŀ}
 FUNCTION  ChrFind  (col,rig:integer):char;                                {}
{          FUNZIONE che lascia  nella variabile  "ChrFind",   di tipo CHAR,}
{          il codice del carattere Ascii presente alle coordinate "Col,Rig,}
{          passate come parametro alla Funzione stessa                     }
{}
 VAR indirizzo: WORD;
     depo: CHAR;
 BEGIN
     indirizzo:= (Col-1)*2+(Rig-1)*160;
     asm
       PUSH ES
       PUSH DI
       MOV  AX,0B800H
       MOV  ES,AX
       MOV  DI,indirizzo
       MOV  AL,ES:[DI]
       MOV  depo,AL
       POP  ES
       POP  DI
     end;
     ChrFind:=depo;
 END; { FINE FUNCTION  ChrFind *********************************************}

     {Ŀ}
 END.{***** FINE della LIBRERIA PERSONALE "GIOBE.PAS"   *******************}
     {}

