unit tastiere;
interface
uses crt,giobe;
procedure tasto2vuoto(x,y:byte);
var k:byte;
procedure tasto2vtridi(x,y:byte);
procedure tastovdtridi(x,y:byte);
procedure tastovstridi(x,y:byte);
procedure tastovuotodestra(x,y:byte);
procedure tastovuotosinistra(x,y:byte);
procedure tastiera;
procedure ombre;
procedure tridimensionalita(x,y:byte;tipo:string);
implementation
procedure tasto2vuoto(x,y:byte);
{quasta procedura disegna un tasto avente come spigolo in alto a sinistra il
punto avente le coordinate di x e y.con il vuoto sia a destra che a sinistra
in modo che ci abbia un diesis sia a destra che a sinistra}
begin
   gotoxy(x,y);
   for k:=1 to 6 do
   begin
      writeln('');
      y:=y+1;
      gotoxy(x,y);
   end;
   gotoxy(x+2,y-6);
   writeln(' ');
   gotoxy(x+2,y-5);
   writeln(' ');
   gotoxy(x+2,y-4);
   writeln(' ');
   gotoxy(x,y-6);
   writeln(' ');
   gotoxy(x,y-5);
   writeln(' ');
   gotoxy(x,y-4);
   writeln(' ');
end;
procedure tasto2vtridi(x,y:byte);
begin
   gotoxy(x,y);
   for k:=1 to 5 do
   begin
      writeln('');
      y:=y+1;
      gotoxy(x,y);
   end;
   gotoxy(x,y);
   writeln('');
   textcolor(black);
   gotoxy(x+2,y-5);writeln(' ');
   gotoxy(x+2,y-4);writeln(' ');
   gotoxy(x+2,y-3);writeln(' ');
   gotoxy(x,y-5);writeln(' ');
   gotoxy(x,y-4);writeln(' ');
   gotoxy(x,y-3);writeln(' ');
end;
procedure tastovdtridi(x,y:byte);
{Questa procedura da' l'effetto di tridimensionalita con il tasto che ha il
vuoto a destra(vd), con il tasto che ha come spigolo in alto a sinistra le
coordinate del punto x,y}
begin
   gotoxy(x,y);
   for k:=1 to 5 do
   begin
      writeln('');
      y:=y+1;
      gotoxy(x,y);
   end;
   gotoxy(x,y);
   writeln('');
   textcolor(black);
   gotoxy(x+2,y-5);writeln(' ');
   gotoxy(x+2,y-4);writeln(' ');
   gotoxy(x+2,y-3);writeln(' ');
end;
procedure tastovstridi(x,y:byte);
{Questa procedura  uguale alla prcedente ma con il tasto che ha il vuoto a destra}
begin
   gotoxy(x,y);
   for k:=1 to 5 do
   begin
      writeln('');
      y:=y+1;
      gotoxy(x,y);
   end;
   gotoxy(x,y);
   writeln('');
   textcolor(black);
   gotoxy(x,y-5);writeln(' ');
   gotoxy(x,y-4);writeln(' ');
   gotoxy(x,y-3);writeln(' ');
end;
procedure tastovuotodestra(x,y:byte);
{Questa procedura disegna un tasto avente un vuoto a destra e come spigolo in
alto a sinistra le coordinate del punto x,y}
begin
   gotoxy(x,y);
   for k:=1 to 6 do
   begin
      writeln('');
      y:=y+1;
      gotoxy(x,y);
   end;
   gotoxy(x+2,y-6);
   writeln(' ');
   gotoxy(x+2,y-5);
   writeln(' ');
   gotoxy(x+2,y-4);
   writeln(' ');
end;
procedure tastovuotosinistra(x,y:byte);
{Questa procedura  uguale alla precedente ma con il vuoto a sinistra}
begin
   gotoxy(x,y);
   for k:=1 to 6 do
   begin
      writeln('');
      y:=y+1;
      gotoxy(x,y);
   end;
   gotoxy(x,y-6);
   writeln(' ');
   gotoxy(x,y-5);
   writeln(' ');
   gotoxy(x,y-4);
   writeln(' ');
end;
procedure tastiera;
{Questa procedura disegna una tastiera servendosi delle procedure precedentemente
elencate}
begin
   tastovuotodestra(1,1);
   tasto2vuoto(5,1);
   tastovuotosinistra(9,1);
   tastovuotodestra(13,1);
   tasto2vuoto(17,1);
   tasto2vuoto(21,1);
   tastovuotosinistra(25,1);
   tastovuotodestra(29,1);
   tasto2vuoto(33,1);
   tastovuotosinistra(37,1);
   tastovuotodestra(41,1);
   tasto2vuoto(45,1);
   tasto2vuoto(49,1);
   tastovuotosinistra(53,1);
   tastovuotodestra(57,1);
   tasto2vuoto(61,1);
   tastovuotosinistra(65,1);
   tastovuotodestra(69,1);
   tasto2vuoto(73,1);
   tasto2vuoto(77,1);
   gotoxy(1,8);
   write('DO  RE  MI  FA  SOL LA  SI  DO  RE  MI  FA  SOL LA  SI  DO  RE  MI  FA  SOL LA');
end;
procedure ombre;
{Questa procedura disegna sotoo ogni tasto l'ombreggiatura che d l'efetto
di tridimensionalit}
begin
   gotoxy(2,7);
   textcolor(7);
   writeln('                    ');
end;
procedure tridimensionalita(x,y:byte;tipo:string);
{Questa procedura si serve di altre procedure per dare un'effetto di
tridimensinalita quando si preme un tasto}
begin
   if tipo='vuoto destra' then
   begin
      textcolor(black);
      tastovuotodestra(x,y);
      gotoxy(x+1,y+6);
      writeln('   ');
      textcolor(white);
      tastovdtridi(x+1,y+1);
      if pulmou=1 then repeat until pulmou=0;
      textcolor(7);
      gotoxy(x+1,y+6);
      writeln('');
      textcolor(white);
      tastovuotodestra(x,y);
      gotoxy(x+3,y);writeln(' ');
      gotoxy(x+3,y+1);writeln(' ');
      gotoxy(x+3,y+2);writeln(' ');
      gotoxy(x+3,y+3);writeln(' ');
      gotoxy(x+3,y+4);writeln(' ');
      gotoxy(x+3,y+5);writeln(' ');
   end;
   if tipo='vuoto sinistra' then
   begin
      textcolor(black);
      tastovuotosinistra(x,y);
      gotoxy(x+1,y+6);writeln('   ');
      textcolor(white);
      tastovstridi(x+1,y+1);
      if pulmou=1 then repeat until pulmou=0;
      textcolor(black);
      tastovstridi(x+1,y+1);
      textcolor(7);
      gotoxy(x+1,y+6);writeln('');
      textcolor(white);
      tastovuotosinistra(x,y);
   end;
   If tipo='2 vuoti' then
   begin
      textcolor(black);
      tasto2vuoto(x,y);
      gotoxy(x+1,y+6);writeln('   ');
      textcolor(white);
      tasto2vtridi(x+1,y+1);
      if pulmou=1 then repeat until pulmou=0;
      textcolor(black);
      tasto2vtridi(x+1,y+1);
      textcolor(7);
      gotoxy(x+1,y+6);writeln('');
      textcolor(white);
      tasto2vuoto(x,y);
   end;
end;
end.
